#include<iostream>
#include<vector>
#include<queue>
#include<stack>
using namespace std;
string s;
vector<vector<int> > cuts;
void gen(int i, int n, vector<int> curr)
{
    //cout << i << " " << n << endl;
    if(i == s.size() - 1 && curr.size() != n) return;
    if(curr.size() == n)
    {
        cuts.push_back(curr);
        return ;
    }
    gen(i + 1, n, curr);
    curr.push_back(i);
    gen(i + 1, n, curr);
}
vector<int> ev;
int eval(vector<int> a)
{
    int cnt = 0;
    int ans = 0;
    int j = 1;
    for(int i = 0; i < s.size(); i ++)
    {
        if(s[i] == '(') cnt ++;
        else
        {
            if(cnt)
            {
                ans ++;
                cnt --;
            }
        }
        if(a[j] == i)
        {
            cnt = 0;
            j ++;
        }
    }
    return ans;
}
bool cmp(vector<int> &a, vector<int> &b)
{
    for(int i = 1; i < a.size(); i ++)
    {
        if(a[i] < b[i]) return true;
        if(a[i] > b[i]) return false;
    }
}
void print_ans(vector<int> a)
{
    for(int i = 1; i < a.size(); i ++)
    {
        cout << i << ",";
        cout << "[" << a[i - 1] + 2 << "," << a[i] + 1 << "],";
        priority_queue<int> pairs;
        stack<int> open;
        for(int j = a[i - 1] + 1; j <= a[i]; j ++)
        {
            if(s[j] == '(') open.push(j);
            else {
                if(!open.empty())
                {
                    pairs.push(-open.top());
                    open.pop();
                    pairs.push(-j);
                }
            }
        }
        cout << pairs.size() << ":";
        while(!pairs.empty())
        {
            cout << " " << -pairs.top() + 1;
            pairs.pop();
        }
        cout << endl;
    }
}
int main()
{
    cin >> s;
    int k;
    cin >> k;
    k --;
    ev.push_back(-1);
    gen(0, k + 1, ev);
    int mp = -1;
    for(int i = 0; i < cuts.size(); i ++)
    {
        cuts[i].push_back(s.size() - 1);
        int x = eval(cuts[i]);
        if(mp == -1 || mp > x)   mp = x;
    }
    vector<int> mf;
    vector<int> ml;
    for(int i = 0; i < cuts.size(); i ++)
    {
        if(eval(cuts[i]) == mp)
        {
            if(mf.size() == 0 || cmp(mf, cuts[i]))  mf = cuts[i];
            if(ml.size() == 0 || cmp(cuts[i], ml))  ml = cuts[i];
        }
    }
    cout << mp * 2 << endl;
    print_ans(ml);
    print_ans(mf);

    /*
    cout << endl;

    for(int i = 0; i < cuts.size(); i ++)
    {
        for(int j = 0; j < cuts[i].size(); j ++)
        {
            cout << cuts[i][j] << " ";
        }
        cout << " = " << eval(cuts[i]);
        cout << endl;
    }
    */
}
