#include <iostream>
#include <string>
#include <vector>
#include <stack>
#include <algorithm>
using namespace std;
const int MAX_K = 200;
const int MAX_N = 1e3 + 24;
int N, K, a[MAX_K], reala[MAX_K], ans;
vector <int> vreal[MAX_N], vind[MAX_N], len[MAX_N];
string s;
stack <int> st;
void solvep()
{
    a[K + 1] = N;
    int curans = 0;
    for(int j = 1; j <= K + 1; ++ j)
    {
        for(int i = a[j - 1]; i < a[j]; ++ i)
        {
            if(s[i] == '(')   st.push(i + 1);
            else
            {
                if(!st.empty())
                {
                    int cu = st.top();
                    st.pop();
                    curans += 2;
                    vind[j].push_back(cu);
                    vind[j].push_back(i + 1);
                }
            }
        }
        while(!st.empty())   st.pop();
    }
    if(curans < ans)
    {
        ans = curans;
        for(int i = 1; i <= K + 1; ++ i)
        {
            reala[i] = a[i];
            vreal[i] = vind[i];
        }

    }
    for(int i = 1; i <= K + 1; ++ i)   vind[i].clear();
}
void solve(int curr, int pr)
{
    if(curr > K)
    {
        solvep();
        return;
    }
    for(int i = pr + 1; i < N; ++ i)
    {
        a[curr] = i;
        solve(curr + 1, i);
    }
}
int main()
{
    cin >> s >> K;
    -- K;
    N = s.size();
    ans = N + K + 10;
    solve(1, 0);
    cout << ans << "\n";
    for(int i = 1; i <= K + 1; ++ i)
    {
        cout << i << ",[" << reala[i - 1] + 1 << "," << reala[i] << "]," << vreal[i].size() << ":";
        sort(vreal[i].begin(), vreal[i].end());
        for(int j = 0; j < vreal[i].size(); ++ j)   cout << vreal[i][j] << " ";
        cout << "\n";
    }
    for(int i = 1; i <= K + 1; ++ i)
    {
        cout << i << ",[" << reala[i - 1] + 1 << "," << reala[i] << "]," << vreal[i].size() << ":";
        for(int j = 0; j < vreal[i].size(); ++ j)   cout << vreal[i][j] << " ";
        cout << "\n";
    }
    return 0;
}
