#include <iostream>
#include <cstdio>
#include <vector>
using namespace std;
const int MAX_N = 1e5 + 24;
int N, M, A, B, ans;
bool used[MAX_N];
vector <int> v[MAX_N];
void dfs(int curr, int st)
{
    if(curr == B)
    {
        if(st > ans)   ans = st;
        return;
    }
    int sz = v[curr].size();
    for(int i = 0; i < sz; ++ i)
    {
        if(used[v[curr][i]] == false)
        {
            used[v[curr][i]] = true;
            dfs(v[curr][i], st + 1);
            used[v[curr][i]] = false;
        }
    }
}
int main()
{
    ios_base :: sync_with_stdio(0);
    cin.tie(0);
    int a, b;
    cin >> N >> M >> A >> B;
    for(int i = 1; i <= M; ++ i)
    {
        cin >> a >> b;
        v[a].push_back(b);
        v[b].push_back(a);
    }
    used[A] = true;
    dfs(A, 0);
    cout << ans << "\n";
    return 0;
}
