#include <cstdio>
#include <vector>
#include <ctime>
using namespace std;
const int MAX_N = 1e5 + 24;
int N, M, A, B, ans;
bool used[MAX_N];
vector <int> v[MAX_N];
void dfs(int curr, int st)
{
    if((double) clock() / (double) CLOCKS_PER_SEC > 0.29999)   return;
    if(curr == B)
    {
        if(st > ans)   ans = st;
        return;
    }
    int sz = v[curr].size();
    for(int i = 0; i < sz; ++ i)
    {
        if(used[v[curr][i]] == false)
        {
            used[v[curr][i]] = true;
            dfs(v[curr][i], st + 1);
            if((double) clock() / (double) CLOCKS_PER_SEC > 0.29999)   return;
            used[v[curr][i]] = false;
        }
    }
}
int main()
{
    int a, b;
    scanf("%d%d%d%d", &N, &M, &A, &B);
    for(int i = 1; i <= M; ++ i)
    {
        scanf("%d%d", &a, &b);
        v[a].push_back(b);
        v[b].push_back(a);
    }
    used[A] = true;
    dfs(A, 0);
    printf("%d\n", ans);
    return 0;
}
/**
10 12 2 5
1 10
10 9
9 8
8 7
7 6
6 5
5 4
4 6
6 10
10 3
3 2
2 1
**/
