#include <bits/stdc++.h>
#define endl '\n'

using namespace std;
template<class T, class T1> void chkmax(T &x, const T1 &y) { if(x < y) x = y; }
template<class T, class T1> void chkmin(T &x, const T1 &y) { if(x > y) x = y; } 
const int MAXN = (1 << 20);

struct point
{
	int64_t x, y;
	point() { x = y = 0; }
	point(int64_t _x, int64_t _y) { x = _x; y = _y; } 
};

point operator-(point a, point b) { return point(a.x - b.x, a.y - b.y); } 
point operator+(point a, point b) { return point(a.x + b.x, a.y + b.y); } 

int n;
vector<point> p;

void read()
{
	cin >> n;
	for(int i = 0; i < n; i++)
	{
		point tmp;
		cin >> tmp.x >> tmp.y;
		p.push_back(tmp);
	}
}

bool cmp(point a, point b)
{
	if(a.x == b.x) return a.y < b.y;
	return a.x < b.x;
}

vector<point> get_ch(vector<point> li)
{
	vector<point> ret;
	sort(li.begin(), li.end(), cmp);
	return ret;
}

void solve()
{
	cout << 0 << endl;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	
	read();
	solve();
	return 0;
}
