#include <bits/stdc++.h>
#define endl '\n'

using namespace std;
template<class T, class T1> void chkmax(T &x, const T1 &y) { if(x < y) x = y; }
template<class T, class T1> void chkmin(T &x, const T1 &y) { if(x > y) x = y; } 
const int MAXN = (1 << 20);
const double inf = 1e17 + 42;

struct point
{
	int64_t x, y, idx;
	point() { x = y = idx = 0; }
	point(int64_t _x, int64_t _y, int _idx = -1) { x = _x; y = _y; idx = _idx; } 
};

point operator-(point a, point b) { return point(a.x - b.x, a.y - b.y); } 
point operator+(point a, point b) { return point(a.x + b.x, a.y + b.y); } 

int n;
vector<point> p;

void read()
{
	cin >> n;
	for(int i = 0; i < n; i++)
	{
		point tmp;
		cin >> tmp.x >> tmp.y;
		tmp.idx = i + 1;
		p.push_back(tmp);
	}
}

bool cmp(point a, point b)
{
	if(a.x == b.x) return a.y < b.y;
	return a.x < b.x;
}

double slope(point a, point b)
{
	double dx = a.x - b.x;
	double dy = a.y - b.y;
	if(dx == 0) return inf;
	return dy / dx;
}

map<pair<int64_t, int64_t>, bool> used; 

vector<point> get_ch(vector<point> li)
{
	vector<point> ret;
	sort(li.begin(), li.end(), cmp);
	
	for(int i = 0; i < li.size(); i++)
	{
		while(ret.size() >= 2 && slope(ret.back(), li[i]) < slope(li[i], ret[ret.size() - 2])) ret.pop_back();
		ret.push_back(li[i]);
	}
	
	ret.pop_back();
	
	int beg = ret.size();
	for(int i = li.size() - 1; i >= 0; i--)
	{
		while(ret.size() >= beg + 2 && slope(ret.back(), li[i]) < slope(li[i], ret[ret.size() - 2])) ret.pop_back();
		ret.push_back(li[i]);
	}
	
	ret.pop_back();
	return ret;
}

bool ok()
{
	vector<point> ch = get_ch(p);
	for(auto it: ch) used[{it.x, it.y}] = true;
	for(auto it: p)
		if(!used.count({it.x, it.y})) 
			return false;
	
	return true;
}

void solve()
{
	vector<pair<int, int> > answer;
	while(!ok())
	{
		
	}	
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	
	read();
	solve();
	return 0;
}
