#include <iostream>
#include <vector>
#include <cstdint>
#include <ctime>
#include <unistd.h>

using namespace std;

uint32_t a, b;

#define TIME_TO_STOP 300000U

vector < vector < uint32_t > > ss;
vector < bool > used;

void init()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    uint32_t n, m;
    cin>>n>>m>>a>>b;
    a--;
    b--;
    ss.resize(n);
    used.resize(n);
    used[a]=true;
    uint32_t u, v;
    for(uint32_t i=0; i<m; i++)
    {
        cin>>u>>v;
        u--; v--;
        ss[u].push_back(v);
        ss[v].push_back(u);
    }
}

uint32_t res=0;

void rec (uint32_t cur=a, uint32_t cur_br=0)
{
    if(clock()>=TIME_TO_STOP)return;
    if(cur==b)
    {

        if(cur_br>res)
            res=cur_br;

        return;
    }

    for(uint32_t i=0; i<ss[cur].size(); i++)
    {
        if(used[ss[cur][i]])continue;
        used[ss[cur][i]]=true;
        rec(ss[cur][i], cur_br+1);
        used[ss[cur][i]]=false;
        if(clock()>=TIME_TO_STOP)return;
    }
}

int main()
{
    init();
    rec();
    cout<<res<<endl;

    return 0;
}
