# include <cstdio>
# include <cstring>
# include <algorithm>

using namespace std;

const int MAX_N = 1024;
const int MAX_K = 256;

int n, k;

char c[MAX_N];

int dp[MAX_N][MAX_K];
int re[2][MAX_N][MAX_K];

int pa[MAX_N][MAX_N];
int an[MAX_N][MAX_N];

void print (int l, int r)
{
	if (!pa[l][r])
		return;
	if (pa[l][r] == 1)
		print (l, r - 1);
	if (pa[l][r] == 3)
		print (l + 1, r);
	if (pa[l][r] == 2)
	{
		printf ("%d ", l);
		print (l + 1, r - 1);
		printf ("%d ", r);
	}
	if (pa[l][r] > 3)
	{
		int idx = pa[l][r] - 3;
		print (l, idx);
		print (idx + 1, r);
	}
}

int main ()
{
	int i, j, t;
	scanf ("%s", c + 1);
	scanf ("%d", &k);
	
	n = strlen (c + 1);
	
	for (j = 1; j <= n; j ++)
	{
		an[j][j] = 0;
		for (i = j - 1; i >= 1; i --)
		{
			if (n > 400)
			{
				for (t = i; t <= min (j, i + 50); t ++)
					if ((an[i][t] + an[t + 1][j]) > an[i][j])
					{
						an[i][j] = an[i][t] + an[t + 1][j];
						pa[i][j] = 3 + t;
					}
				
				for (int kkk = 0; kkk < 50; kkk ++)
				{
					t = rand () % (j - i + 2) + i;
					if ((an[i][t] + an[t + 1][j]) > an[i][j] || ((an[i][t] + an[t + 1][j]) == an[i][j] && pa[i][j] > 3 + t))
					{
						an[i][j] = an[i][t] + an[t + 1][j];
						pa[i][j] = 3 + t;
					}
				}
			}	
			else
				for (t = i; t <= j; t ++)
					if ((an[i][t] + an[t + 1][j]) > an[i][j])
					{
						an[i][j] = an[i][t] + an[t + 1][j];
						pa[i][j] = 3 + t;
					}
						
			if (c[i] == '(' && c[j] == ')' && an[i + 1][j - 1] + 1 > an[i][j])
			{
				an[i][j] = an[i + 1][j - 1] + 1;
				pa[i][j] = 2;
			}
			
			///printf ("%d %d = %d - %d\n", i, j, an[i][j], pa[i][j]);
		}
	}
	
	
	for (i = n; i >= 1; i --)
	{
		dp[i][1] = an[i][n];
		re[0][i][1] = n;
		
		
		///printf ("min %d %d = %d - %d\n", i, 1, dp[i][1], n);
		///printf ("max %d %d = %d - %d\n", i, 1, dp[i][1], n);
		
		for (t = 2; t <= k; t ++)
		{
			dp[i][t] = (1 << 30);
			re[0][i][t] = -1;
			
			for (j = n - (t - 1) + 1; j > i; j --)
			{
				if (dp[j][t - 1] + an[i][j - 1] < dp[i][t])
				{
					dp[i][t] = dp[j][t - 1] + an[i][j - 1];
					re[0][i][t] = j - 1;
				}
			}
			
			///printf ("min %d %d = %d - %d\n", i, t, dp[i][t], re[0][i][t]);
		}
		
		
		re[1][i][1] = n;
		
		for (t = 2; t <= k; t ++)
		{
			re[1][i][t] = -1;
			
			for (j = i + 1; j <= n - (t - 1) + 1; j ++)
			{
				if (dp[j][t - 1] + an[i][j - 1] == dp[i][t])
				{
					re[1][i][t] = j - 1;
					break;
				}
			}
			
			///printf ("max %d %d = %d - %d\n", i, t, dp[i][t], re[1][i][t]);
		} 
	}
	
	printf ("%d\n", dp[1][k] * 2);
	
	int x;
	
	for (x = 1, i = 1; i <= k; i ++)
	{
		printf ("%d,[%d,%d],%d:", i, x, re[1][x][k - i + 1], an[x][re[1][x][k - i + 1]] * 2);
		print (x, re[1][x][k - i + 1]);
		printf ("\n");
		
		x = re[1][x][k - i + 1] + 1;
	}
	
	for (x = 1, i = 1; i <= k; i ++)
	{
		printf ("%d,[%d,%d],%d:", i, x, re[0][x][k - i + 1], an[x][re[0][x][k - i + 1]] * 2);
		print (x, re[0][x][k - i + 1]);
		printf ("\n");
		
		x = re[0][x][k - i + 1] + 1;
	}
	
	return 0;
}

