# include <cstdio>
# include <cstdlib>
# include <vector>
# include <queue>

using namespace std;

const int MAX_N = 1e5 + 10;

int n, m, a, b;

vector <int> v[MAX_N];

int in[MAX_N], ou[MAX_N], tin;

void dfs (int x)
{
	in[x] = ++ tin;
	for (int i = 0; i < (int) v[x].size (); i ++)
		if (!in[v[x][i]])
			dfs (v[x][i]);
	ou[x] = tin;
}

int last;

int u[MAX_N];

queue <pair <int, pair <int, int>>> q;

pair <int, int> walk (int x, int par)
{

	///printf ("-- %d %d %d - %d %d %d\n", x, par, ti);
	
	while (!q.empty ())
		q.pop ();
	q.push ({x, {1, par}});
	
	u[x] = 1;
	
	int ti;
	
	while (!q.empty ())
	{
		pair <int, pair <int, int>> f = q.front ();
		q.pop ();
		
		x = f.first;
		ti = f.second.first;
		par = f.second.second; 	
	
		if (x == b || (v[x].size () > 2 && in[x] <= in[b] && in[b] <= ou[x]))
		{
			last = x;
			u[x] = false;
			return {ti, par};
		}
	
		for (int i = 0; i < (int) v[x].size (); i ++)
			if (!u[v[x][i]])
			{
				u[v[x][i]] = 1;
				q.push ({v[x][i], {ti + 1, x}});
			}
	}
	return {-1, -1};
}

int go (int x, int par1, int par2)
{
	int ans_sum = 0;
	while (x != b)
	{
		
		if (x == -1 || u[x])
		{
			printf ("yoyo\n");
			exit (0);
		}
		
		u[x] = 1;
		
		///printf ("-- %d = %d %d %d\n", ans_sum, x, par1, par2);

		pair <int, int> crr;
		pair <int, int> ansl = {-1, -1}, ansr;
	
		int to = -1;
	
		for (int i = 0; i < (int) v[x].size (); i ++)
		{
			if (v[x][i] == par1 || v[x][i] == par2)
				continue;
			
			///printf ("== %d\n", v[x][i]);
			last = -1;
			crr = walk (v[x][i], x);
			///printf ("%d %d %d\n", last, crr.first, crr.second);
			if (crr.first != -1 && last != -1)
			{
				ansr = ansl;
				ansl = crr;
				to = last;	
			}
		}
	
		
		///printf ("%d %d %d %d %d\n", to, ansl.first, ansl.second, ansr.first, ansr.second);
	
		
	
		if (ansl < ansr)
			ans_sum += ansr.first;
		else
			ans_sum += ansl.first;
		
		x = to;
		par1 = ansl.second;
		par2 = ansr.second;
	
	}
	return ans_sum;
}

int main ()
{
	int p, qq, i, j;
	scanf ("%d%d%d%d", &n, &m, &a, &b);
	
	for (i = 0; i < m; i ++)
	{
		scanf ("%d%d", &p, &qq);
		v[p].push_back (qq);
		v[qq].push_back (p);
	}
	
	dfs (a);
	
	///for (i = 1; i <= n; i ++)
	///	printf ("%d %d %d\n", i, in[i], ou[i]);
	
	printf ("%d\n", go (a, -1, -1));
	

	
	return 0;
}

