# include <cstdio>
# include <cstring>
# include <vector>
# include <algorithm>

using namespace std;

const int MAX_N = 1024;
const int MAX_K = 256;

int n, k;

char c[MAX_N];

int dp[MAX_N][MAX_K];
int re[2][MAX_N][MAX_K];

int an[MAX_N][MAX_N];

void print (int l, int r)
{
	int i;
	
	vector <int> v, ans;
	
	for (i = l; i <= r; i ++)
	{
		if (c[i] == '(')
			v.push_back (i);
		else
		{
			if (v.size ())
			{
				ans.push_back (v[v.size () - 1]);
				ans.push_back (i);
				v.pop_back ();
			}
		}
	}
	
	sort  (ans.begin (), ans.end ());
	
	for (i = 0; i < (int) ans.size (); i ++)
		printf ("%d ", ans[i]);
}

int main ()
{
	int i, j, t;
	scanf ("%s", c + 1);
	scanf ("%d", &k);
	
	n = strlen (c + 1);
	
	for (i = 1; i <= n; i ++)
	{
		int c_ans = 0, cnt = 0;
		for (j = i; j <= n; j ++)
		{
			if (c[j] == '(')
				cnt ++;
			else
				if (cnt > 0)
				{
					cnt --;
					c_ans ++;
				}
			an[i][j] = c_ans;
		}
	}
	
	
	for (i = n; i >= 1; i --)
	{
		dp[i][1] = an[i][n];
		re[0][i][1] = n;
		re[1][i][1] = n;
		
		int f = min (k, n - i + 2);
		
		for (t = 2; t <= f; t ++)
		{
			dp[i][t] = (1 << 30);
			re[0][i][t] = -1;
			re[1][i][t] = -1;
			
			for (j = n - (t - 1) + 1; j > i; j --)
			{
				if (dp[j][t - 1] + an[i][j - 1] < dp[i][t])
				{
					dp[i][t] = dp[j][t - 1] + an[i][j - 1];
					re[0][i][t] = j - 1;
					re[1][i][t] = j - 1;
				}
				else
					if (dp[j][t - 1] + an[i][j - 1] == dp[i][t])
						re[1][i][t] = j - 1;
			}
		}
	}
	
	printf ("%d\n", dp[1][k] * 2);
	
	int x;
	
	for (x = 1, i = 1; i <= k; i ++)
	{
		printf ("%d,[%d,%d],%d:", i, x, re[1][x][k - i + 1], an[x][re[1][x][k - i + 1]] * 2);
		print (x, re[1][x][k - i + 1]);
		printf ("\n");
		
		x = re[1][x][k - i + 1] + 1;
	}
	
	for (x = 1, i = 1; i <= k; i ++)
	{
		printf ("%d,[%d,%d],%d:", i, x, re[0][x][k - i + 1], an[x][re[0][x][k - i + 1]] * 2);
		print (x, re[0][x][k - i + 1]);
		printf ("\n");
		
		x = re[0][x][k - i + 1] + 1;
	}
	
	return 0;
}

