#include <iostream>
#include <vector>
using namespace std;

vector<vector<int>> v;
int n,m,a,b;
bool used[100005];
int maxRoute[100005];

void dfsMax(int i, int routeL){
    used[i] = true;
    if(maxRoute[i] < routeL){
        maxRoute[i] = routeL;
    }

    for(int j = 0; j < v[i].size(); j++){
        int x = v[i][j];
        if(used[x] == false){
            dfsMax(x, routeL + 1);
            used[x] = false;
        }
    }
}

int main()
{
    cin>>n>>m>>a>>b;
    for(int i = 1; i <= n; i++){
        v.push_back(vector<int>());
    }

    int t1,t2;
    for(int i = 1; i <= m; i++){
        cin>>t1>>t2;
        v[t1].push_back(t2);
        v[t2].push_back(t1);
    }

    dfsMax(a,0);

    cout<<maxRoute[b]<<endl;
    return 0;
}
