#include<iostream>
#include<queue>
#include<vector>
using namespace std;

const int MAX_N=100002;

struct edges{
	int to=-1,teglo=0;
	bool operator< (const edges & a) const {
		return a.teglo>this->teglo;
	}
};

vector<int> susedi[MAX_N];
vector<int> teglo[MAX_N];
vector<bool> minato[MAX_N];
int used[MAX_N];
int cikli[MAX_N];
edges vruzki[MAX_N];
priority_queue<edges> q;

void diikstra(edges curr){
	q.push(curr);
	while(!q.empty()){
		curr=q.top();
		//cout<<curr.to<<" "<<curr.teglo<<endl;
		q.pop();
		if(curr.teglo<used[curr.to] or used[curr.to]==-1){
			for(int i=0;i<susedi[curr.to].size();i++){
				//cout<<"A";
				if((curr.teglo+teglo[curr.to][i]<used[susedi[curr.to][i]] or used[susedi[curr.to][i]]==-1) and !minato[curr.to][i]){
					edges x;
					minato[curr.to][i]=true;
					x.to=susedi[curr.to][i];
					x.teglo=curr.teglo+teglo[curr.to][i];
					q.push(x);
				}
			}
			used[curr.to]=curr.teglo;
		}
	}
}

int main(){
	cin.tie(0);
	ios::sync_with_stdio(false);
	int vurhove,rebra,a,b;
	cin>>vurhove>>rebra>>a>>b;
	for(int i=0;i<rebra;i++){
		int x,y,z;
		cin>>x>>y;
		//cin>>z;
		z=1;
		minato[x].push_back(false);
		minato[y].push_back(false);
		susedi[x].push_back(y);
		susedi[y].push_back(x);
		teglo[x].push_back(z);
		teglo[y].push_back(z);
	}
	for(int i=1;i<=vurhove;i++){
		used[i]=-1;
	}
	edges x;x.to=a;x.teglo=0;
	diikstra(x);
	cout<<used[b]<<endl;
	return 0;
}
