#include<iostream>
#include<algorithm>
#include<cstring>
#include<vector>
#include<map>
#include<set>
#include<cmath>
#include<queue>
#include<cstdlib>
#include<cstdio>
using namespace std;
int br[100005];
vector<int> v[100005];
int n,m,a,b;
int used[100005];
void read()
{
    int x,y;
    int i,j;
    cin>>n>>m>>a>>b;
    for(i=0;i<m;i++)
    {
        cin>>x>>y;
        v[x].push_back(y);
        v[y].push_back(x);
    }
}
int idx;
void bfs(int x)
{
    int i,j;
    queue<int> q;
    int nb,sz;
    used[x]=idx;
    q.push(x);
    while(!q.empty())
    {
        x=q.front();
        q.pop();
        br[idx]++;
        sz=v[x].size();
        for(i=0;i<sz;i++)
        {
            nb=v[x][i];
            if(!used[nb]&&v[nb].size()<=2)
            {
                used[nb]=idx;
                q.push(nb);
            }
        }
    }
}
void build()
{
    int i;
    for(i=1;i<=n;i++)
    {
        if(!used[i]&&v[i].size()<=2)
        {
            idx++;
            bfs(i);
        }
    }
}
int par[100005];
int dfs(int x, int dp)
{
    //cout<<x<<" "<<dp<<endl;
    if(x==b)
    {
        dp=max(dp,br[used[x]]-dp+1);
        return dp;
    }
    int i,j,sz,nb;
    sz=v[x].size();
    if(sz>2)
    {
        dp=max(dp,br[used[par[x]]]-dp+1);
    }
    int mx=0;
    int res;
    for(i=0;i<sz;i++)
    {
        nb=v[x][i];
        if(par[nb]) continue;
        par[nb]=x;
        if(sz>2&&used[nb]!=used[par[x]])
        {
            res=dfs(nb,1);
            if(res>mx)
            {
                mx=res;
            }
        }
        else if(sz>2)
        {
            res=dfs(nb,dp+1);
            if(res>mx)
                mx=res;
        }
        else
        {
            return dfs(nb,dp+1);
        }
    }
    if(mx>0)
    {
        return dp+mx;
    }
    return 0;
}
int solve1(int x, int dp)
{
    if(x==b)
    {
        return max(dp,br[used[x]]-dp+1);
    }
    int i,sz,nb;
    sz=v[x].size();
    for(i=0;i<sz;i++)
    {
        nb=v[x][i];
        if(par[nb])
            continue;
        if(used[nb]>0)
        {
            if(used[nb]!=used[b])
                continue;
        }
        par[nb]=x;
        return solve1(nb,dp+1);
    }
}
int main()
{
	read();
	build();
    par[a]=a;
    //cout<<used[a]<<" "<<used[b]<<endl;
	if(used[a]==used[b])
    {
        cout<<solve1(a,0)<<endl;
        return 0;
    }
	cout<<dfs(a,0)<<endl;
	return 0;
}
/*
10 12 2 5
1 10
10 9
9 8
8 7
7 6
6 5
5 4
4 6
6 10
10 3
3 2
2 1
*/
