#include <iostream>
#include <string>
#include <stack>
#include <vector>
using namespace std;
int k,n,ds[1001],ls[1001];
bool iztr[1001];
vector <int> dp[203],dpli[203],dpri[203];
string s;

struct Node
{
    Node *l,*r;
    int li,ri,mn,lazy=0,lmni,rmni;
    Node(int li,int ri):li(li),ri(ri){l=nullptr; r=nullptr;}
};
typedef Node* Nodep;

Nodep root;

struct Tree
{
    vector<int> a;
    Tree(vector<int>v):a(v){root = new Node(0,n-1);}

    void Update(Nodep v)
    {
        int lazy = v->lazy;
        v->lazy = 0;
        v->mn+= lazy;
        if(v->l==nullptr) return;
        v->l->lazy += lazy;
        v->r->lazy += lazy;
    }

    void Update2(Nodep v)
    {
        if(v->l->mn == v->r->mn)
            v->lmni=v->l->lmni, v->rmni=v->r->rmni;
        else if(v->l->mn < v->r->mn)
            v->lmni=v->l->lmni, v->rmni=v->l->rmni;
        else v->lmni=v->r->lmni, v->rmni=v->r->rmni;
        v->mn=min(v->l->mn,v->r->mn);
    }

    void Build(Nodep v=root)
    {
        int li = v->li, ri = v->ri;
        if(li==ri)
        {
            v->lmni=v->rmni = li;
            v->mn=a[li];
            return;
        }
        int m=(li+ri)/2;
        Build(v->l=new Node(li,m));
        Build(v->r=new Node(m+1,ri));
        Update2(v);
    }

    void Add(int li,int ri,int add,Nodep v=root)
    {
        Update(v);
        if(v->ri < li ||  ri < v->li) return;
        if(v->ri <= ri && li <= v->li)
        {
            //cout<<"add ";
           // cerr<<v->li<<" "<<v->ri<<" "<<v->mn<<" "<<v->lmni<<" "<<v->rmni<< endl;
            v->lazy+=add;
            Update(v);
            return;
        }
        Add(li,ri,add,v->l);
        Add(li,ri,add,v->r);
        Update2(v);
    }

    void Calc(int li,int ri,int &ansli,int &ansri,int &ans,Nodep v=root)
    {
        Update(v);
        if(v->ri < li ||  ri < v->li) return;
        if(v->ri <= ri && li <= v->li)
        {
          //  cerr<<v->li<<" "<<v->ri<<" "<<v->mn<<" "<<v->lmni<<" "<<v->rmni<< endl;
            if(v->mn < ans)
            {
                ans = v->mn;
                ansri = v->rmni;
                ansli = v->lmni;
            }
            if(v->mn == ans)
            {
                ansri = max(ansri, v->rmni);
                ansli = min(ansli, v->lmni);
            }
            return;
        }
        Calc(li,ri,ansli,ansri,ans,v->l);
        Calc(li,ri,ansli,ansri,ans,v->r);
    }
};

void print(int pos,int tekk,int mode) //1-l, 0 -r
{
    int li,ri=pos;
    if(tekk>0)
    {
        if(mode==1)
            li=dpli[tekk][pos]+1;
        else
            li=dpri[tekk][pos]+1;
        print(li-1,tekk-1,mode);
        cout<<tekk<<",["<<li+1<<","<<ri+1<<"],"<<2*dp[tekk][pos] - 2*(tekk==1?0:dp[tekk-1][li-1])<<":";
        for(int i=li; i<=pos; i++)
        {
           // cerr<<"asdasd"<<tekk<<" "<<i<<" "<< ds[i]<<endl;
            if(!iztr[i])
                if(s[i]=='(')
                   {if(ds[i]<=pos)cout<<1+i<<" ";}
                else
                   {if(ls[i]>=li)cout<<1+i<<" ";}
        }
        cout<< endl;
    }
}

void solve()
{
    for(int i=2; i<=k; i++)
    {
        Tree tree(dp[i-1]);
        tree.Build();
        for(int j=i-1; j<n; j++)
        {
            if(!iztr[j] && s[j]==')') tree.Add(0,ls[j]-1,1);
            tree.Calc(i-2,j-1,dpli[i][j],dpri[i][j],dp[i][j]);
           // cerr<<i<<" "<<j<<" "<<dp[i][j]<< endl;
        }
    }
    cout<<2*dp[k][n-1]<< endl;
    print(n-1,k,1);
    print(n-1,k,0);
}

void preproc()
{
    stack <int> st;
    n=s.size();
    for(int i=1; i<=k; i++)
    {
        dp[i].resize(n+2,1000000);
        dpli[i].resize(n+2,1000000);
        dpri[i].resize(n+2,-1);
    }
    int br=0;
    for(int i=0; i<n; i++)
    {
        br+=(s[i]=='(')?1:-1;
        if(br<0) iztr[i]=1, br++;
    }
    br=0;
    for(int i=n-1; i>=0; i--)
    {
        br+=(s[i]==')')?1:-1;
        if(br<0) iztr[i]=1, br++;
    }
    br=0;
    for(int i=0; i<n; i++)
    {
        if(!iztr[i])
            if(s[i]=='(') st.push(i);
            else
            {
                ds[ st.top() ] = i;
               // cerr<<st.top()<<" "<<i<< endl;
                ls[ i ] = st.top();
                st.pop();
                br++;
            }
        dp[1][i]=br;
        dpli[1][i]=dpri[1][i]=-1;
    }
}

int main()
{
    //cin.tie(0);
    //ios::sync_with_stdio(0);
    cin>>s>>k;
    preproc();
    solve();
    return 0;
}
