#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#include <set>
#define pb push_back
#define mp make_pair
using namespace std;
const int N=1e5+5;

int n,m,A,B;

bool vis[N];
vector <int> nb[N];
int faces;

int ans;

vector <int> comp[N];
int sz_comp[N],components;
int rep[N];

bool in_path[N];
vector <int> path;
void DFS_simple(int v,int par=-1)
{
   vis[v]=true;
   in_path[v]=true;
   path.pb(v);

   for(int i=0;i<nb[v].size();i++)
   {
      if(in_path[nb[v][i]] && nb[v][i] != par)
      {
         components++;
         int j=(int)path.size()-1;
         while(1)
         {
             comp[path[j]].pb(components);
             rep[components]=path[j];

             sz_comp[components]++;
             if(path[j] == nb[v][i])
                break;
             j--;
         }
      }

      if(!vis[nb[v][i]])
        DFS_simple(nb[v][i],v);
   }

   path.pop_back();
   in_path[v]=false;
}

int best[N];

bool best_sort(int x,int y)
{
    return best[x] > best[y];
}

void DFS(int v,int len)
{
    if(v == B)
        ans=len;

    vis[v]=true;

    for(int i=0;i<nb[v].size();i++)
    {
        if(!vis[nb[v][i]])
            DFS(nb[v][i],len+1);
    }
}

int main()
{
   int i,j;
   int u,v;

   scanf("%d%d%d%d", &n, &m, &A, &B);
   for(i=1;i<=m;i++)
   {
       scanf("%d%d", &u, &v);
       nb[u].pb(v);
       nb[v].pb(u);
   }

   faces=2+m-n;
   faces--;

   DFS_simple(1);

   for(i=1;i<=n;i++)
   {
       for(j=0;j<comp[i].size();j++)
       {
           best[i]=max(best[i],sz_comp[comp[i][j]]);
       }
   }

   for(i=1;i<=n;i++)
   {
       sort(nb[i].begin(),nb[i].end(),best_sort);
   }

   memset(vis,false,sizeof(vis));
   DFS(A,1);



   cout<<ans<<endl;

   return 0;
}

/*

10 12 2 5
1 10
10 9
9 8
8 7
7 6
6 5
5 4
4 6
6 10
10 3
3 2
2 1

*/

