#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#include <set>
#include <map>
#define pb push_back
#define mp make_pair
using namespace std;
const int N=1e5+5;
const int INF=1e9;

int n,m,A,B;

int vis[N];
vector <int> nb[N];
int faces;

int ans;

vector <int> comp[N];
int sz_comp[N],components;
int rep[N];

bool in_path[N];
vector <int> path;
void DFS_simple(int v,int par=-1)
{
   vis[v]=true;
   in_path[v]=true;
   path.pb(v);

   for(int i=0;i<nb[v].size();i++)
   {
      if(in_path[nb[v][i]] && nb[v][i] != par)
      {
         components++;
         int j=(int)path.size()-1;
         while(1)
         {
             comp[path[j]].pb(components);
             rep[components]=path[j];

             sz_comp[components]++;
             if(path[j] == nb[v][i])
                break;
             j--;
         }
      }

      if(!vis[nb[v][i]])
        DFS_simple(nb[v][i],v);
   }

   path.pop_back();
   in_path[v]=false;
}

set <int> s[N],used[N];
set <int>::iterator it;

vector <int> comp_nb[N];

map <int,int> dp[N];

int DFS_solve(int v,int cur_comp,int len,int parent=-1)
{
    if(used[cur_comp].find(v) != used[cur_comp].end())
        return dp[cur_comp][v];

    used[cur_comp].insert(v);
    if(v == B)
    {
        if(len > 0)
         dp[cur_comp][v]=max(sz_comp[cur_comp]-len,len);
        else
         dp[cur_comp][v]=0;

        return dp[cur_comp][v];
    }

    int res=-INF;
    for(int i=0;i<nb[v].size();i++)
    {
       // if(nb[v][i] == parent)
          //  continue;
        for(int j=0;j<comp[nb[v][i]].size();j++)
        {
            if(cur_comp != comp[nb[v][i]][j])
              res=max(res,DFS_solve(nb[v][i],comp[nb[v][i]][j],0,v));
            else
              res=max(res,DFS_solve(nb[v][i],comp[nb[v][i]][j],len+1,v));
        }
    }

    if(len > 0)
     res+=max(sz_comp[cur_comp]-len,len);

    dp[cur_comp][v]=res;

    return res;
}

int main()
{
   int i,j,k;
   int u,v;

   scanf("%d%d%d%d", &n, &m, &A, &B);
   for(i=1;i<=m;i++)
   {
       scanf("%d%d", &u, &v);
       nb[u].pb(v);
       nb[v].pb(u);
   }

   faces=2+m-n;
   faces--;

   DFS_simple(1);

  /* for(i=1;i<=n;i++)
   {
       cerr<<i<<": ";
       for(j=0;j<comp[i].size();j++)
       {
           cerr<<comp[i][j]<<" ";
       }
       cerr<<endl;
   }*/

   for(i=1;i<=n;i++)
   {
       for(j=0;j<comp[i].size();j++)
       {
           s[i].insert(comp[i][j]);
       }
   }


   for(i=1;i<=n;i++)
   {
       for(j=0;j<comp[i].size();j++)
       {
           for(k=j+1;k<comp[i].size();k++)
           {
               comp_nb[comp[i][j]].pb(comp[i][k]);
               comp_nb[comp[i][k]].pb(comp[i][j]);
           }
       }
   }

  /* for(i=1;i<=components;i++)
   {
       cerr<<i<<": ";
       for(j=0;j<comp_nb[i].size();j++)
       {
           cerr<<comp_nb[i][j]<<" ";
       }
       cerr<<endl;
   }*/


   int ans=0;
   for(i=0;i<comp[A].size();i++)
   {
       ans=max(ans,DFS_solve(A,comp[A][i],0));
   }

   printf("%d ANS\n", ans);



   return 0;
}

/*

10 12 2 5
1 10
10 9
9 8
8 7
7 6
6 5
5 4
4 6
6 10
10 3
3 2
2 1

*/
