#include<iostream>
#include<stdio.h>
#include<string>
#include<vector>
#include<queue>
#include<algorithm>
#include<stack>
using namespace std ;

#define MAXN 1007
#define MAXK 207

#define inf 1000000007

int n , k ;
string a ;
int f[ MAXN ][ MAXN ] ;
int fst[ MAXN ] ;
int rem[ MAXN ][ MAXN ] ;

int dp[ MAXN ][ MAXK ] ;

int lstpos[ MAXN ][ MAXK ] ;
int fstpos[ MAXN ][ MAXK ] ;

vector < pair < int , int > > maxans ;
vector < pair < int , int > > minans ;

void input ( ) {
	cin >> a ;
	cin >> k ;
	n = a.size ( ) ;
	a = '#' + a ;
}


void get ( int st , int en ) {
	int x , y ;
	x = st ;
	y = en ;
	vector < int > v ;
	v.clear ( ) ;
	queue < pair < int , int > > q ;
	q.push ( make_pair ( x , y ) ) ;
	while ( q.empty ( ) == false ) {
		pair < int , int > aux = q.front ( ) ;
		q.pop ( ) ;
		x = aux.first ;
		y = aux.second ;
		if ( x >= y ) { continue ; }
		if ( rem[ x ][ y ] == -1 ) { q.push ( make_pair ( x , y - 1 ) ) ; }
		else {
			v.push_back ( rem[ x ][ y ] ) ;
			v.push_back ( y ) ;
			q.push ( make_pair ( x , rem[ x ][ y ] - 1 ) ) ;
		}
	}
	sort ( v.begin ( ) , v.end ( ) ) ;
	int i ;
	for ( i = 0 ; i < f[ st ][ en ] ; i ++ ) {
		printf ( " %d" , v[ i ] ) ;
	}
	printf ( "\n" ) ;
}

void solve ( ) {
	int i , j , t ;
	for ( i = 1 ; i <= n ; i ++ ) {
		for ( j = i ; j <= n ; j ++ ) {
			if ( a[ j ] == '(' ) { fst[ i ] = j ; break ; }
		}
		if ( j > n ) { 
			fst[ i ] = n + 1 ;
		}
	}
	for ( i = 1 ; i <= n ; i ++ ) {
		stack < int > s ;
		for ( j = i ; j <= n ; j ++ ) {
			if ( a[ j ] == '(' ) { s.push ( j ) ; f[ i ][ j ] = f[ i ][ j - 1 ] ; rem[ i ][ j ] = -1 ; }
			else {
				if ( s.empty ( ) == true ) { f[ i ][ j ] = f[ i ][ j - 1 ] ; rem[ i ][ j ] = -1 ; }
				else { f[ i ][ j ] = f[ i ][ s.top ( ) - 1 ] + 2 ; rem[ i ][ j ] = s.top ( ) ; s.pop ( ) ; }
			}
		}
	}
	//printf ( "%d\n" , tot ) ;	
	for ( i = 0 ; i <= n ; i ++ ) {
		for ( j = 0 ; j <= k ; j ++ ) {
			dp[ i ][ j ] = inf ;
		}
	}
	dp[ 0 ][ 0 ] = 0 ;
	for ( j = 1 ; j <= k ; j ++ ) {
		for ( i = 1 ; i <= n ; i ++ ) {
			for ( t = i - 1 ; t >= 0 ; t -- ) {
				int cur = dp[ t ][ j - 1 ] + f[ t + 1 ][ i ] ;
				if ( dp[ i ][ j ] > cur ) {
					dp[ i ][ j ] = cur ;
					lstpos[ i ][ j ] = t ;
					fstpos[ i ][ j ] = t ;
				}
				if ( dp[ i ][ j ] == cur ) {
					fstpos[ i ][ j ] = t ;
				}
			}
		}
	}
	printf ( "%d\n" , dp[ n ][ k ] ) ;
	int x = n ;
	int y = k ;
	while ( x > 0 ) {
		maxans.push_back ( make_pair ( fstpos[ x ][ y ] + 1 , x ) ) ;
		x = fstpos[ x ][ y ] ;
		y -- ;
	}
	x = n ;
	y = k ;
	while ( x > 0 ) {
		minans.push_back ( make_pair ( lstpos[ x ][ y ] + 1 , x ) ) ;
		x = lstpos[ x ][ y ] ;
		y -- ;
	}
	for ( i = k - 1 ; i >= 0 ; i -- ) {
		printf ( "%d,[%d,%d],%d:" , k - i , maxans[ i ].first , maxans[ i ].second , f[ maxans[ i ].first ][ maxans[ i ].second ] ) ;
		get ( maxans[ i ].first , maxans[ i ].second ) ;
	}

	for ( i = k - 1 ; i >= 0 ; i -- ) {
		printf ( "%d,[%d,%d],%d:" , k - i , minans[ i ].first , minans[ i ].second , f[ minans[ i ].first ][ minans[ i ].second ] ) ;
		get ( minans[ i ].first , minans[ i ].second ) ;
	}
}

int main ( ) {
	input ( ) ;
	solve ( ) ;
	return 0 ;
}
