#include<iostream>
#include<stdio.h>
#include<vector>
#include<queue>
#include<stack>
#include<algorithm>
using namespace std ;

#define MAXN 100007

int n , m ;
int st , en ;
vector < int > v[ MAXN ] ;


int id ;
vector < int > chain[ MAXN ] ;


int used[ MAXN ] ;
int ord[ MAXN ] ;
int revord[ MAXN ] ;
int tm ;

vector < pair < int , int > > aux ;

int ostdeg[ MAXN ] ;

int prv[ MAXN ] ;
int nxt[ MAXN ] ;

int dist[ MAXN ] ;

vector < int > revchain[ MAXN ] ;
vector < int > positions[ MAXN ] ;
bool used_chain[ MAXN ] ;


bool cmp ( pair < int , int > p1 , pair < int , int > p2 ) {
	return ( revord[ p1.second ] - revord[ p1.first ] < revord[ p2.second ] - revord[ p2.first ] ) ;
}

void bfs ( int vertex ) {
	queue < int > q ;
	q.push ( vertex ) ;
	dist[ vertex ] = 1 ;
	int i , j ;
	while ( q.empty ( ) == false ) {
		int x = q.front ( ) ;
		q.pop ( ) ;
		int sz = revchain[ x ].size ( ) ;
		for ( i = 0 ; i < sz ; i ++ ) {
			if ( used_chain[ revchain[ x ][ i ] ] == true ) { continue ; }
			int h = revchain[ x ][ i ] ;
			int w = positions[ x ][ i ] ;
			int g = chain[ h ].size ( ) ;
			for ( j = 0 ; j < g ; j ++ ) {
				if ( j == w ) { continue ; }
				int cur1 , cur2 ;
				cur1 = w - j ;
				if ( cur1 < 0 ) { cur1 = -cur1 ; }
				cur2 = g - cur1 ; 
				dist[ chain[ h ][ j ] ] = max ( cur1 , cur2 ) + dist[ x ] ;
				if ( v[ chain[ h ][ j ] ].size ( ) > 2 ) {
					q.push ( chain[ h ][ j ] ) ;
				}
			}
			used_chain[ revchain[ x ][ i ] ] = true ;
		}
	}
}



void dfs ( int vertex , int prv ) {
	tm ++ ;
	ord[ tm ] = vertex ;
	revord[ vertex ] = tm ;
	used[ vertex ] = 2 ;
	int i ;
	int sz = v[ vertex ].size ( ) ;
	for ( i = 0 ; i < sz ; i ++ ) {
		if ( v[ vertex ][ i ] == prv ) { continue ; }
		if ( used[ v[ vertex ][ i ] ] == 1 ) { continue ; }
		if ( used[ v[ vertex ][ i ] ] == 2 ) {
			aux.push_back ( make_pair ( v[ vertex ][ i ] , vertex ) ) ;
		}
		else {
			dfs ( v[ vertex ][ i ] , vertex ) ;
		}
	}
	used[ vertex ] = 1 ;
}


void input ( ) {
	scanf ( "%d%d%d%d" , &n , &m , &st , &en ) ;
	int i ;
	for ( i = 1 ; i <= m ; i ++ ) {
		int x , y ;
		scanf ( "%d%d" , &x , &y ) ;
		v[ x ].push_back ( y ) ;
		v[ y ].push_back ( x ) ;
	}
	tm = 0 ;
}

void solve ( ) {
	int i , j ;
	id = 0 ;
	for ( i = 1 ; i <= ( n / 2 ) ; i ++ ) {
		if ( used[ i ] == 0 ) { 
			dfs ( i , -1 ) ;
		}
	}
	for ( i = n ; i >= ( n / 2 ) ; i -- ) {
		if ( used[ i ] == 0 ) { 
			dfs ( i , -1 ) ;
		}
	}

	int sz = aux.size ( ) ;
	/**
	for ( i = 0 ; i < sz ; i ++ ) {
		printf ( "%d %d\n" , aux[ i ].first , aux[ i ].second ) ;
	}
	**/
	sort ( aux.begin ( ) , aux.end ( ) , cmp ) ;
	for ( i = 1 ; i <= n ; i ++ ) {
		ostdeg[ i ] = v[ i ].size ( ) ;
	}
	for ( i = 1 ; i <= n ; i ++ ) { nxt[ i ] = i + 1 ; prv[ i ] = i - 1 ; }
	for ( i = 0 ; i < sz ; i ++ ) {
		int x = aux[ i ].second ;
		int h = revord[ aux[ i ].second ] ;
		id ++ ;
		while ( x != aux[ i ].first ) {
			chain[ id ].push_back ( x ) ;
			ostdeg[ x ] -= 2 ;
			if ( ostdeg[ x ] == 0 ) {
				prv[ nxt[ h ] ] = prv[ h ] ;
				nxt[ prv[ h ] ] = nxt[ h ] ;
			}
			h = prv[ h ] ;
			x = ord[ h ] ;
		}
		ostdeg[ x ] -= 2 ;
		if ( ostdeg[ x ] == 0 ) {
			prv[ nxt[ h ] ] = prv[ h ] ;
			nxt[ prv[ h ] ] = nxt[ h ] ;
		}
		chain[ id ].push_back ( x ) ;
	}
	//printf ( "%d\n" , sz ) ;
	for ( i = 1 ; i <= sz ; i ++ ) {
		int g = chain[ i ].size ( ) ;
		for ( j = 0 ; j < g ; j ++ ) {
			revchain[ chain[ i ][ j ] ].push_back ( i ) ;
			positions[ chain[ i ][ j ] ].push_back ( j ) ;
			//printf ( "%d " , chain[ i ][ j ] ) ;
		}
		//printf ( "\n" ) ;
	}
	bfs ( st ) ;
	printf ( "%d\n" , dist[ en ] - 1 ) ;
}

int main ( ) {
	input ( ) ;
	solve ( ) ;
	return 0 ;
}
