#include <iostream>
#include <vector>
using namespace std;
vector < int > cyc[(1<<20)];
int cntCyc, cycInd[(1<<20)];

int n, m, u, v;
vector < int > neigh[(1<<20)];
bool onP[(1<<20)], lenTo[(1<<20)];
bool used[(1<<20)];

int ansLen = 0;

bool dfs ( int x, int len ) {
    if ( used[x] ) { return 0; }
    used[x] = 1;

    if ( x == v ) {
        onP[v] = 1;
        lenTo[v] = len;
        return 1;
    }

    for ( int i = 0 ; i < neigh[x].size() ; i ++ ) {
        if ( dfs ( neigh[x][i], len+1 ) ) {
            lenTo[x] = len;
            onP[x] = 1;
            return 1;
        }
    }
    return 0;
}
bool inCyc[(1<<20)];
bool inq[(1<<20)];
vector < int > cp;

void getCyc ( int x, int p ) {

    if ( used[x] ) {
        if ( !inq[x] ) { return; }
        cyc[cntCyc].push_back( x );
        inCyc[x]= 1;

        for ( int i = cp.size()-1 ; cp[i] != x; i -- ) {
            cyc[cntCyc].push_back( cp[i] );
            inCyc[cp[i]]= 1;
        }
        cntCyc ++;
        return;
    }else {
        inq[x] = 1;
        cp.push_back( x );
    }
    used[x] = 1;

    for ( int i = 0 ; i < neigh[x].size() ; i ++ ) {
        if ( neigh[x][i] == p ) { continue; }
        getCyc( neigh[x][i], x );
    }
    inq[x] = 0;
    cp.pop_back();
}


int main () {
    cin >> n >> m;
    cin >> u >> v;

    for ( int i = 0 ; i < m ; i ++ ) {
        int a, b;
        cin >> a >> b;
        neigh[a].push_back( b );
        neigh[b].push_back( a );
    }
    dfs( u, 0 );
    for ( int i = 0 ; i <= n ; i ++ ) { used[i] = 0; }
    getCyc(u, -1);
    /*
    for ( int i = 0 ; i < cntCyc ; i ++ ) {
        for ( int j = 0 ; j < cyc[i].size() ; j ++ ) {
            cout << cyc[i][j] << " ";
        }
        cout << "\n";
    }
    */
    int ans = 0;
    for ( int i = 0 ; i < cntCyc ; i ++ ) {
        int cnt1 = 0;
        for ( int j = 0 ; j < cyc[i].size() ; j ++ ) {
            if ( onP[ cyc[i][j] ] ) { cnt1 ++; }
        }
//        cout << "in cyc " << i << " : " << cnt1 << "\n";
        if ( cnt1 >= 2 ) {
            ans += max( cnt1-1, (int)cyc[i].size()-cnt1+1 );
        }
    }
    cout << ans << "\n";
    return 0;
}
/*
10 12 2 5
1 10
10 9
9 8
8 7
7 6
6 5
5 4
4 6
6 10
10 3
3 2
2 1
*/
