#include <iostream>
#include <cstring>
#include <vector>
#include <algorithm>
using namespace std;

char arr[1042];
int k, n;
int sum[1042][1042];

void getSum ( int s ) {
    int cntO = 0, crr = 0;
    for ( int i = s ; i < n ; i ++ ) {
        sum[s][i] = crr*2;

        if ( arr[i] == '(' ) { cntO++; }
        else {
            if ( cntO ) {
                cntO--;
                crr ++;
            }
        }
    }
    sum[s][n] = crr*2;
}
int dp[1042][1042];
int pos[1042][1042];

void getSol ( int x, int ck, int posL, int posR ) {

    pos[ck][x] = posL;
    dp[ck][x] = (1<<20);

    for ( int i = posL ; i < posR && i < x ; i ++ ) {
        if ( dp[ck-1][i] + sum[i][x] < dp[ck][x] ) {
            dp[ck][x] = dp[ck-1][i] + sum[i][x];
            pos[ck][x] = i;
        }
    }
}

void solve ( int l, int r, int posL, int posR, int ck ) { /// [l, r) ; [posL, posR)
    if ( l >= r ) { return; }


    int m = (l+r)/2;
    getSol( m, ck, posL, posR );

    int p = pos[ck][m];
//    cout << "solving " << l << " " << m << " " << r << " : " << posL << " " << p << " " << posR << "\n";

    solve( l, m, posL, p+1, ck );
    solve( m+1, r, p, posR, ck );

}
vector < int > o, ret;
void printSol ( int s, int f ) {
    o.clear();
    ret.clear();

    for ( int i = s ; i < f; i ++ ) {
        if ( arr[i] == '(') {
            o.push_back( i );
        }else {
            if ( o.size() ) {
                ret.push_back( o.back() );
                ret.push_back( i );
                o.pop_back();
            }
        }
    }
    sort( ret.begin(), ret.end() );
    for ( int i = 0 ; i < ret.size() ; i ++ ) {
        cout << ret[i]+1 << " ";
    }
}

vector < pair < int, int > > sol1, sol2;
int main () {

    cin >> arr >> k;
    n = strlen( arr );

    if ( n < k ) { cout << 12/0 << "\n";  }

    for ( int i = 0 ; i <= n ; i ++ ) {
        getSum ( i );
        dp[0][i] = (1<<20);
    }
    dp[0][0] = 0;

    /*
    for ( int i = 0 ; i < n ; i ++ ) {
        for ( int j = 0 ; j <= n ; j ++ ) {
            cout << sum[i][j] <<  " ";
        }
        cout << "\n";
    }
    cout << "\n";
    */

    for ( int i = 0 ; i <= n ; i ++ ) {
        dp[1][i] = sum[0][i];
    }

    for ( int ck = 2 ; ck <= k ; ck ++ ) {
        solve( 0, n+1, 0, n+1, ck );
    }

    /*
    for ( int i = 1 ; i <= k ; i ++ ) {
        for ( int j = 0 ; j <= n ; j ++ ) {
            cout << dp[i][j] << " " << pos[i][j] << "  |   ";
        }
        cout << "\n";
    }
    */

    int lastEnd = n;
    for ( int ck = k ; ck > 0 ; ck -- ) {
        for ( int i = 0 ; i < lastEnd ; i ++ ) {
            if ( dp[ck][lastEnd] == dp[ck-1][i] + sum[i][lastEnd] ) {
                sol1.push_back( make_pair( i, lastEnd ) );
                lastEnd = i;
                break;
            }
        }
    }
    lastEnd = n;
    for ( int ck = k ; ck > 0 ; ck -- ) {
        for ( int i = lastEnd-1 ; i >= 0 ; i -- ) {
            if ( dp[ck][lastEnd] == dp[ck-1][i] + sum[i][lastEnd] ) {
                sol2.push_back( make_pair( i, lastEnd ) );
                lastEnd = i;
                break;
            }
        }
    }


    reverse  ( sol1.begin(), sol1.end() );
    reverse  ( sol2.begin(), sol2.end() );

    cout << dp[k][n] << "\n";

//    sol1[0].first = 0;
//    sol2[0].first = 0;
   // if ( sol1[0].first != 0 ) { cout << 12/0 << "\n"; }
   // if ( sol2[0].first != 0 ) { cout << 12/0 << "\n"; }

    int csum = 0;

    for ( int i = 0 ; i < sol1.size() ; i ++ ) {
        cout << i+1 <<",[" << sol1[i].first+1 << "," << sol1[i].second << "]," << sum[sol1[i].first][sol1[i].second] << ":" ;
        printSol( sol1[i].first, sol1[i].second );
        csum += sum[sol1[i].first][sol1[i].second];
        cout << "\n";
    }
    if ( csum != dp[k][n] ){ cout << 12/0 << "\n"; }

    csum = 0;
    for ( int i = 0 ; i < sol2.size() ; i ++ ) {
        cout << i+1 <<",[" << sol2[i].first+1 << "," << sol2[i].second << "]," << sum[sol2[i].first][sol2[i].second] << ":" ;
        printSol( sol2[i].first, sol2[i].second );
        csum += sum[sol2[i].first][sol2[i].second];
        cout << "\n";
    }

    if ( csum != dp[k][n] ){ cout << 12/0 << "\n"; }

    return 0;
}
/*
(()(()
2
*/
