#include <iostream>
#include <cstdio>
#include <vector>
#include <cstring>
using namespace std;

const int N=(1e5)+5;
const int LIMIT=5005;

vector <int> g[N],cp,p[N],polygon[LIMIT];
vector < pair <int,int> > conn[N],path;
int used[N];
int inorder[N],order[LIMIT][LIMIT];
int cycle,in,iter;
int a,b;

void DFS(int v,int prev)
{
 int i,j,num;

 used[v]=iter;
 cp.push_back(v);
 in++;
 inorder[v]=in;

  for(i=0;i<g[v].size();i++)
  {
   if(used[g[v][i]]!=iter)
    DFS(g[v][i],v);
   else
   {
    if(g[v][i]!=prev && inorder[g[v][i]]<inorder[v])
    {
     cycle++;
     num=0;

      for(j=cp.size()-1;j>=0;j--)
      {
       p[cp[j]].push_back(cycle);
       polygon[cycle].push_back(cp[j]);
       num++;
       order[cycle][cp[j]]=num;

        if(cp[j]==g[v][i])
         break;
      }
    }
   }
  }

 cp.pop_back();
}

int ans,inda,indb;

void GetDistance()
{
 int i,cc,curpoint,prevpoint,sum,sz,dist;


 /*cout<<"-----------------";
  for(i=0;i<path.size();i++)
   cout<<path[i].first<<" "<<path[i].second<<endl;*/

 sum=0;
  for(i=1;i<path.size();i++)
  {
   cc=path[i].first;
   curpoint=path[i].second;
   prevpoint=path[i-1].second;

   sz=polygon[cc].size();
   dist=order[cc][curpoint]-order[cc][prevpoint];
   dist=abs(dist);
   dist=max(dist,sz-dist);
   sum+=dist;
  }

  cc=path[0].first;
  curpoint=path[0].second;
  prevpoint=a;

  sz=polygon[cc].size();
  dist=order[cc][curpoint]-order[cc][prevpoint];
  dist=abs(dist);
  dist=max(dist,sz-dist);
  sum+=dist;

  cc=p[b][indb];
  curpoint=b;
  prevpoint=path.back().second;

  sz=polygon[cc].size();
  dist=order[cc][curpoint]-order[cc][prevpoint];
  dist=abs(dist);
  dist=max(dist,sz-dist);
  sum+=dist;

  ans=max(ans,sum);
}

void Go(int v,int prev)
{
 int i;

  if(v==p[b][0])
  {
   indb=0;
   GetDistance();
   return;
  }

  if(p[b].size()==2)
  {
   if(v==p[b][1])
   {
    indb=1;
    GetDistance();
    return;
   }
  }

  for(i=0;i<conn[v].size();i++)
  {
   if(conn[v][i].first!=prev)
   {
    path.push_back(make_pair(v,conn[v][i].second));
    Go(conn[v][i].first,v);
    path.pop_back();
   }
  }
}

int main()
{

int n,m,u,v,i,j;

scanf("%d%d%d%d",&n,&m,&a,&b);

 for(i=1;i<=m;i++)
 {
  scanf("%d%d",&u,&v);
  g[u].push_back(v);
  g[v].push_back(u);
 }

iter++;
DFS(a,0);

 for(i=1;i<=n;i++)
 {
  if(p[i].size()==2)
  {
   conn[p[i][0]].push_back(make_pair(p[i][1],i));
   conn[p[i][1]].push_back(make_pair(p[i][0],i));
  }
 }

inda=0;
Go(p[a][0],0);

 if(p[a].size()==2)
 {
  inda=1;
  Go(p[a][1],0);
 }

printf("%d\n",ans);

return 0;
}
