#include <iostream>
#include <vector>
using namespace std;
const int maxN=100010;
struct edge{
int b,e;
};
edge edges[2*maxN];
vector<int> graph[maxN];
int n,m,a,b;
int ans,used[maxN],len,dist[maxN];
void dfs(int a,int b)
{
    if(a==b){
        ans=max(ans,len);
        return;
    }
    used[a]=1;
    for(int i=0;i<graph[a].size();i++)
    {
        if(!used[graph[a][i]] && dist[a]+1>=dist[graph[a][i]])
        {
            dist[graph[a][i]]=dist[a]+1;
            used[graph[a][i]]=1;
            len++;
            dfs(graph[a][i],b);
            used[graph[a][i]]=0;
            len--;
        }
    }
}
int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cin>>n>>m>>a>>b;
    int i,beg,e;
    for(i=0;i<m;i++)
    {
        cin>>beg>>e;
        graph[beg].push_back(e);
        graph[e].push_back(beg);
    }
    dist[a]=0;
    dfs(a,b);
    cout<<ans<<endl;
    return 0;
}
/**
10 12 2 5
1 10
10 9
9 8
8 7
7 6
6 5
5 4
4 6
6 10
10 3
3 2
2 1
*/
