#include <iostream>
#include <vector>
#include <ctime>
using namespace std;
const int maxN=100010;
struct edge{
int b,e;
};
edge edges[2*maxN];
vector<int> graph[maxN];
int n,m,a,b;
bool tl=0;
int ans,used[maxN],len;
void dfs(int a,int b)
{
    if(tl==1)return;
    if(a==b){
        ans=max(ans,len);
        return;
    }
    time_t t=clock();
    if(t>=280){
        tl=1;
        return;
    }
    used[a]=1;
    for(int i=0;i<graph[a].size();i++)
    {
        if(!used[graph[a][i]])
        {
            used[graph[a][i]]=1;
            len++;
            dfs(graph[a][i],b);
            used[graph[a][i]]=0;
            len--;
        }
    }
}
int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cin>>n>>m>>a>>b;
    int i,beg,e;
    for(i=0;i<m;i++)
    {
        cin>>beg>>e;
        graph[beg].push_back(e);
        graph[e].push_back(beg);
    }
    dfs(a,b);
    cout<<ans<<endl;
    return 0;
}
/**
13 16 1 11
1 2
1 4
2 3
3 5
4 5
5 6
6 7
5 7
6 8
8 9
9 10
6 10
7 11
11 12
12 13
7 13
*/
