#include<iostream>
#include<algorithm>
#include<vector>
#include<stack>
using namespace std;

const int MAX_N=1024;
const int MAX_K=256;

int k,n;
string s;

int maxl[MAX_N][MAX_N];
int ans[MAX_K][MAX_N]; //first is total length, second is end of part
int minparts[MAX_K][MAX_N]; //kth part starts at i
int maxparts[MAX_K][MAX_N];

void input()
{
    cin>>s>>k;
}
void solve()
{
    n=s.size();
    int c;
    int l;
    for (int i=0;i<n;++i)
    {
        c=0;
        l=0;
        for (int j=i;j<n;++j)
        {
            if (s[j]=='(') ++c;
            else if (c>0)
            {
                --c;
                l+=2;
            }
            maxl[i][j]=l;
        }
    }
    for (int i=0;i<=k;++i)
    {
        for (int j=0;j<=n;++j)
        {
            ans[i][j]=-1;
            minparts[i][j]=-1;
            maxparts[i][j]=-1;
        }
    }
    ans[0][n]=0;
    minparts[0][n]=n;
    minparts[0][n]=n;
    int curr;
    int minp;
    int maxp;
    int opt;
    for (int i=1;i<=k;++i)
    {
        for (int j=0;j<n;++j)
        {
            minp=-1;
            maxp=-1;
            opt=-1;
            for (int p=j;p<n;++p)
            {
                if (ans[i-1][p+1]==-1) continue;
                curr=maxl[j][p]+ans[i-1][p+1];
                if (curr<opt || opt==-1)
                {
                    minp=p;
                    maxp=p;
                    opt=curr;
                }
                else if (curr==opt)
                {
                    minp=p;
                }
            }
            ans[i][j]=opt;
            minparts[i][j]=minp;
            maxparts[i][j]=maxp;
        }
    }
    cout<<ans[k][0]<<'\n';
    int currp=0;
    int currk=k;
    stack<int> pos;
    vector<int> poss;
    for (int i=1;i<=k;++i)
    {
        cout<<i<<",["<<currp+1<<','<<maxparts[currk][currp]+1<<"],"<<maxl[currp][maxparts[currk][currp]]<<':';
        while (!pos.empty()) pos.pop();
        poss.resize(0);
        for (int j=currp;j<=maxparts[currk][currp];++j)
        {
            if (s[j]=='(') pos.push(j+1);
            else if (!pos.empty())
            {
                poss.push_back(pos.top());
                poss.push_back(j+1);
                pos.pop();
            }
        }
        sort(poss.begin(),poss.end());
        for (int j=0;j<poss.size();++j)
        {
            cout<<poss[j]<<' ';
        }
        cout<<'\n';
        currp=maxparts[currk][currp]+1;
        --currk;
    }
    currp=0;
    currk=k;
    for (int i=1;i<=k;++i)
    {
        cout<<i<<",["<<currp+1<<','<<minparts[currk][currp]+1<<"],"<<maxl[currp][minparts[currk][currp]]<<':';
        while (!pos.empty()) pos.pop();
        poss.resize(0);
        for (int j=currp;j<=minparts[currk][currp];++j)
        {
            if (s[j]=='(') pos.push(j+1);
            else if (!pos.empty())
            {
                poss.push_back(pos.top());
                poss.push_back(j+1);
                pos.pop();
            }
        }
        sort(poss.begin(),poss.end());
        for (int j=0;j<poss.size();++j)
        {
            cout<<poss[j]<<' ';
        }
        cout<<'\n';
        currp=minparts[currk][currp]+1;
        --currk;
    }
}

int main()
{
    cin.tie(0);
    ios::sync_with_stdio(0);

    input();
    solve();

    return 0;
}
