#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int N = 100007;

int n,m,a,b;
vector < int > v[N];
vector < pair < int, int > > g[N];
bool used[N];
int dist[N];
vector < vector < int > > cycles;
bool in[N];
vector < int > st;
int found;
int cnt[N];
map < pair < int, int >, int > c;

void get_cycle(int what) {
    vector < int > curr;
    int posa=-1,posb=-1,i;

    for(i=(int)(st.size())-1;i>=0;i--) {
        if(st[i]==a) posa=(int)(curr.size());
        if(st[i]==b) posb=(int)(curr.size());

        ++cnt[st[i]];
        curr.push_back(st[i]);
        if(st[i]==what) break;
    }

    if(posa!=-1 && posb!=-1) {
        found=max(abs(posa-posb),(int)(curr.size())-abs(posa-posb));
    }

    cycles.push_back(curr);
}

void dfsv(int node, int from=-1) {
    used[node]=true;
    in[node]=true;
    st.push_back(node);

    int i;

    for(i=0;i<(int)(v[node].size());i++) if(v[node][i]!=from) {
        if(used[v[node][i]]) {
            if(in[v[node][i]]) {
                get_cycle(v[node][i]);
            }
        }
        else {
            dfsv(v[node][i],node);
        }
    }

    in[node]=false;
    st.pop_back();
}

void dfsg(int node) {
    used[node]=true;

    int i;

    for(i=0;i<(int)(g[node].size());i++) if(!used[g[node][i].first]) {
        dist[g[node][i].first]=dist[node]+g[node][i].second;
        dfsg(g[node][i].first);
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int i,j,z,x,y;

    scanf("%d %d %d %d", &n, &m, &a, &b);
    for(i=1;i<=m;i++) {
        scanf("%d %d", &x, &y);
        if(x>y) swap(x,y);
        if(++c[make_pair(x,y)]>1) assert(false);
        v[x].push_back(y);
        v[y].push_back(x);
    }

    found=-1;
    dfsv(a);

    for(i=0;i<(int)(cycles.size());i++) {
        fprintf(stderr, "Cycle %d:", i);
        for(j=0;j<(int)(cycles[i].size());j++) {
            fprintf(stderr, " %d", cycles[i][j]);
        }
        fprintf(stderr, "\n");
    }

    if(found!=-1) {
        printf("%d\n", found);
        return 0;
    }

    for(i=0;i<(int)(cycles.size());i++) {
        for(j=0;j<(int)(cycles[i].size());j++) {
            if(cnt[cycles[i][j]]>1) {
                for(z=0;z<(int)(cycles[i].size());z++) if(z!=j) {
                    int d=max(abs(j-z),(int)(cycles[i].size())-abs(j-z));
                    g[cycles[i][j]].push_back(make_pair(cycles[i][z],d));
                    g[cycles[i][z]].push_back(make_pair(cycles[i][j],d));
                }
            }
        }
    }
    
    memset(used,0,sizeof(used));
    dfsg(a);
    printf("%d\n", dist[b]);

    return 0;
}
