#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int N = 107;

int n;
pair < int, int > a[N];
vector < pair < int, int > > ans;

pair < int, int > jump_over(pair < int, int > a, pair < int, int > b) {
    pair < int, int > t=make_pair(a.first-b.first,a.second-b.second);
    a.first-=2*t.first;
    a.second-=2*t.second;
    return a;
}

long long s(pair < int, int > a, pair < int, int > b, pair < int, int > c) {
    return ((a.first-b.first)*1ll*(a.second+b.second) + (b.first-c.first)*1ll*(b.second+c.second) + (c.first-a.first)*1ll*(c.second+a.second));
}

int get_next(int pos) {
    for(int i=1;i<=n;i++) {
        int curr=i+pos;
        if(curr>n) curr-=n;
        if(a[curr]!=a[pos]) return curr;
    }
    return -1;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int i;

    scanf("%d", &n);
    for(i=1;i<=n;i++) {
        scanf("%d %d", &a[i].first, &a[i].second);
    }

    while(true) {
        bool f=false;
        for(i=1;i<=n;i++) {
            int j=get_next(i);
            assert(j!=-1);
            int z=get_next(z);
            assert(z!=-1);
            if(z==i) {
                a[z]=jump_over(a[z],a[j]);
                ans.push_back(make_pair(z,j));
                f=true;
                continue;
            }
            if(s(a[i],a[j],a[z])<0) {
                ans.push_back(make_pair(j,z));
                a[j]=jump_over(a[j],a[z]);
                f=true;
            }
        }
        if(f==false) break;
    }

    printf("%d\n", (int)(ans.size()));
    for(i=0;i<(int)(ans.size());i++) printf("%d %d\n", ans[i].first, ans[i].second);

    return 0;
}
