#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int N = 107;

int n;
pair < int, int > a[N];
vector < pair < int, int > > ans;

long long s(pair < int, int > a, pair < int, int > b, pair < int, int > c) {
    return ((a.first-b.first)*1ll*(a.second+b.second) + (b.first-c.first)*1ll*(b.second+c.second) + (c.first-a.first)*1ll*(c.second+a.second));
}

void jump(pair < int, int > &a, pair < int,  int > b) {
    pair < int, int > t = make_pair((b.first-a.first)*2,(b.second-a.second)*2);
    a.first+=t.first;
    a.second+=t.second;
}

bool check(int from) {
    int i,j,z;
    for(i=from;i<=n;i++) {
        for(j=i+1;j<=n;j++) {
            for(z=j+1;z<=n;z++) {
                if(s(a[i],a[j],a[z])<0) return false;
            }
        }
    }
    return true;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int i;

    scanf("%d", &n);

    for(i=1;i<=n;i++) {
        scanf("%d %d", &a[i].first, &a[i].second);
    }

    for(i=n-3;i>=1;i--) {
        while(!check(i)) {
            int which=n-rand()%(n-i);
            ans.push_back(make_pair(i,which));
            jump(a[i],a[which]);
        }
    }
    printf("%d\n", (int)(ans.size()));
    for(i=0;i<(int)(ans.size());i++) printf("%d %d\n", ans[i].first, ans[i].second);

    return 0;
}
