#include <iostream>
#include <vector>
using namespace std;

const int MAXN = 100005;

int n, m, a, b;
vector<int> g[MAXN];

bool vis[MAXN];
int timer = 0;
int opt = 0;

void Init()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n >> m >> a >> b;
    for (int i = 0; i < m; ++ i)
    {
        int u, v;
        cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
}

void DFS(int u = a, int d = 0)
{
    if (timer > 1000000)
    {
        return;
    }
    else timer++;

    if (u == b)
    {
        opt = max(opt, d);
        return;
    }

    for (int v : g[u])
    {
        if (vis[v] == 0)
        {
            vis[v] = 1;
            DFS(v, d + 1);
            vis[v] = 0;
        }
    }
}

int main()
{
    Init();

    vis[a] = 1;
    DFS();

    cout << opt << endl;
    return 0;
}

/*
10 12 2 5
1 10
10 9
9 8
8 7
7 6
6 5
5 4
4 6
6 10
10 3
3 2
2 1
*/
