#include<bits/stdc++.h>
const int MAXN=1e5+17;
//#define endl '\n'
using namespace std;

vector<int> G[MAXN];
bool critical[MAXN], used[MAXN];
int go[MAXN];
vector<vector<int> > cyc;
int n, m, a, b;

void make_cyc(int u)
{
    vector<int> temp; temp.push_back(u);

    int vert=u;
    while(go[vert]!=u) temp.push_back(go[vert]), vert=go[vert];
    for(int i=0; i<temp.size(); i++) go[temp[i]]=0;
    cyc.push_back(temp);
}

void dfs(int u, int p)
{
    used[u]=1; go[u]=p;
    for(int i=0; i<G[u].size(); i++)
        if(G[u][i]!=p&&used[G[u][i]]&&critical[G[u][i]]) {go[G[u][i]]=u; make_cyc(G[u][i]);}

    for(int i=0; i<G[u].size(); i++)
        if(G[u][i]!=p&&!used[G[u][i]]) dfs(G[u][i], u);
}

map<int, int> join[MAXN];
int dist[MAXN];
bool uu[MAXN];
void dfs_case(int u, int p)
{
    uu[u]=1;
    for(int i=0; i<G[u].size(); i++)
        if(uu[G[u][i]]==0)
        {
            dist[G[u][i]]=dist[u]+1;
            dfs_case(G[u][i], u);
        }
}

vector<int> G2[MAXN];
vector<int> col[MAXN];
int sz[MAXN];
deque<int> pat;
int prep(int u, int p, int dest)
{
    if(u==dest) sz[u]++;
    for(int i=0; i<G2[u].size(); i++)
    {
        if(G2[u][i]==p) continue;
        prep(G2[u][i], u, dest);
        sz[u]+=sz[G2[u][i]];
    }
}
void path(int u, int p, int dest)
{
    int temp=u;
    while(temp!=dest)
    {
        pat.push_back(temp);
        for(int i=0; i<G2[temp].size(); i++) if(sz[G2[temp][i]]) {temp=G2[temp][i]; break;}
    }
    pat.push_back(temp);
}
int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int cr=0;
    cin>>n>>m>>a>>b;

    for(int i=0; i<m; i++)
    {
        int u, v;
        cin>>u>>v;
        G[u].push_back(v);
        G[v].push_back(u);
    }

    for(int i=1; i<=n; i++) {if(G[i].size()>2) critical[i]=1, cr++;}
    if(cr==0)
    {
        dfs_case(a, a);
        cout<<max(dist[b], m-dist[b]);
        return 0;
    }

    for(int i=1; i<=n; i++)
        if(critical[i]&&!used[i]) dfs(i, i);

    for(int i=0; i<cyc.size(); i++)
        for(int j=0; j<cyc[i].size(); j++) col[cyc[i][j]].push_back(i+1);

    for(int i=1; i<=n; i++)
    {
        if(critical[i])
        {
            for(int j=0; j<col[i].size(); j++)
                for(int k=0; k<col[i].size(); k++)
                    if(col[i][j]!=col[i][k])
                    {
                        G2[col[i][j]].push_back(col[i][k]);
                        join[col[i][j]][col[i][k]]=i;
                    }
        }
    }

    int c1=col[a][0], c2=col[b][0];

    prep(c1, c1, c2);
    path(c1, c1, c2);

    int fs=a, ls=join[pat[0]][pat[1]];
    int ans=0;
    c1=pat[0];

    for(int i=1; i<pat.size()-1; i++)
    {
        int pos1=0, pos2=0;
        for(int j=0; j<cyc[c1-1].size(); j++)
        {
            if(cyc[c1-1][j]==fs) pos1=j;
            if(cyc[c1-1][j]==ls) pos2=j;
        }
        int sz=cyc[c1-1].size();
        if(pos1!=pos2) ans+=max(abs(pos1-pos2), sz-abs(pos1-pos2));
        fs=ls;
        ls=join[pat[i]][pat[i+1]];
        c1=pat[i];
    }

        int pos1=0, pos2=0;
        for(int j=0; j<cyc[c1-1].size(); j++)
        {
            if(cyc[c1-1][j]==fs) pos1=j;
            if(cyc[c1-1][j]==ls) pos2=j;
        }
        int sz=cyc[c1-1].size();
        if(pos1!=pos2) ans+=max(abs(pos1-pos2), sz-abs(pos1-pos2));
        fs=ls;
        ls=b;
        pos1=0, pos2=0;
        for(int j=0; j<cyc[c1-1].size(); j++)
        {
            if(cyc[c1-1][j]==fs) pos1=j;
            if(cyc[c1-1][j]==ls) pos2=j;
        }
        sz=cyc[c1-1].size();
        if(pos1!=pos2) ans+=max(abs(pos1-pos2), sz-abs(pos1-pos2));

    cout<<ans<<endl;

    return 0;
}

/*
10 12 2 5
1 10
10 9
9 8
8 7
7 6
6 5
5 4
4 6
6 10
10 3
3 2
2 1

7 8
4 6
1 2 2 3 3 1 3 4 4 5 5 6 6 7 3 7
*/
