#include <iostream>
#include <vector>
#include <stack>

using namespace std;

int n, m, A, B;
vector <int> roads[100010];
bool used[100010];
int res[100010];

void dfs(int curr, int val)
{
    //cout << curr << ' ' << val << '\n';
    if (res[B] == m - 1)
    {
        return;
    }
    
    if (val > res[curr])
    {
        res[curr] = val;
    }
    
    if (curr == B)
    {
        return;
    }
    
    used[curr] = true;

    for (int i = 0; i < roads[curr].size(); ++i)
    {
        if (!used[roads[curr][i]])
        {
            dfs(roads[curr][i], val + 1);
        }
    }
    used[curr] = false;
}

int main ()
{
    cin.tie(NULL);
    ios::sync_with_stdio(false);
    
    cin >> n >> m >> A >> B;
    for (int i = 0; i < m; ++i)
    {
        int a, b;
        cin >> a >> b;
        roads[a].push_back(b);
        roads[b].push_back(a);

    }
    
    dfs(A, 0);

    cout << res[B] << '\n';
    return 0;
}
