#include <cstdio>
#include <iostream>
#include <vector>
#include <cstring>
#include <utility>
//#include <ctime>

using namespace std;

//clock_t tstart; void startClock(){tstart=clock();}void printClock(){printf("%.4f\n", (clock()-tstart)/(CLOCKS_PER_SEC*1.0));}

long long n, xx, p, curr, q, fhull, cnt;

struct Point
{
    long long x, y;
};

Point all[1<<7], newp;
vector<pair<long long, long long> > ans;
vector<long long> hull;
bool used[1<<7];

bool orientation(Point a, Point b, Point c)
{
    long long ll=(a.x-b.x)*(a.y+b.y)+(b.x-c.x)*(b.y+c.y)+(c.x-a.x)*(c.y+a.y);
    return ll>0?1:0;
}

int main ()
{
    //freopen("i2.txt", "r", stdin);
    scanf("%lld", &n);
    for(int i=0; i<n; ++i)
    {
        scanf("%lld %lld", &all[i].x, &all[i].y);
    }
    cnt=1;
    bool fl=true;
    while(1)
    {
        memset(used, 0, sizeof used);
        hull.clear();
        xx=1LL<<31-1;
        for(int i=0; i<n; ++i)
        {
            if(all[i].x<xx)
            {
                xx=all[i].x;
                p=i;
            }
        }
        do
        {
            if(used[p]) break;
            used[p]=1;
            hull.push_back(p);
            q=(p+1)%n;
            for(int i=0; i<n; ++i)
            {
                if(orientation(all[p], all[i], all[q]))
                {
                    q=i;
                }
            }
            p=q;
        }
        while(1);
        //for(int i:hull) printf("%d ", i+1);
        //printf("\n");
        if((int)hull.size()==n) break;
        fhull=hull[cnt%(hull.size())];
        cnt++;
        for(int i=0; i<n; ++i)
        {
            if(!used[i])
            {
                ans.push_back({i+1, fhull+1});
                //printf("%d not visited - %d, %d\n", i+1, all[i].x, all[i].y);
                newp.x=all[i].x-all[fhull].x;
                newp.y=all[i].y-all[fhull].y;
                newp.x=all[fhull].x-newp.x;
                newp.y=all[fhull].y-newp.y;
                //printf("New - %d, %d\n", newp.x, newp.y);
                all[i]=newp;
            }
        }
    }
    printf("%d\n", (int)ans.size());
    for(pair<long long, long long> i:ans)
    {
        printf("%lld %lld\n", i.first, i.second);
    }
    return 0;
}
