#include <iostream>
#include <string>
#include <algorithm>
#include <stack>
#include <queue>
#define maxn 1024
using namespace std;
int sSize, k;
int leftd[maxn], rightd[maxn]; /// pairs of braces when read from left to right and right to left
int skoba[maxn]; /// the opening bracket of ai is skoba[ai]
int d[maxn][maxn]; /// maximum number of pairs from ai to aj index where i < j
int cutHere[200];
int cutPoints = 0;

void chooseParts(int fromi, int extraLeft, int partNum, int cutIndex)
{
    priority_queue<int> skobi;
    for(int j =cutIndex; j<cutPoints; j++)
    {
        int i = cutHere[j];

        if(d[fromi][i-1] <= extraLeft && partNum  <= k)
        {

            cout  << partNum  << ",["<< fromi+1 << ","<<i+1<<"],"<<d[fromi][i]<<":";
            priority_queue<int> sk2 = skobi;
            stack<int> wtf;
            while(true)
            {
                if(sk2.empty())
                {
                    break;
                }
                wtf.push(sk2.top());
                sk2.pop();
            }
            while(true)
            {
                if(wtf.empty())
                {
                    break;
                }
                cout<<wtf.top()+1<<" ";
                wtf.pop();
            }
            cout<<endl;
            chooseParts(i+1, extraLeft - d[fromi][i-1], partNum + 1, j+1);
        }
        skobi.push(cutHere[j]+1);
        skobi.push(skoba[cutHere[j]+1]);
    }
    if(partNum  == k+1)
    {
        cout  << partNum  << ",["<< fromi+1 << ","<<sSize<<"],"<<d[fromi][sSize-1]<<":";
        stack<int> wtf;
        while(true)
        {
            if(skobi.empty())
            {
                break;
            }
            wtf.push(skobi.top());
            skobi.pop();
        }
        while(true)
        {
            if(wtf.empty())
            {
                break;
            }
            cout<<wtf.top()+1<<" ";
            wtf.pop();
        }
        cout<<endl;
    }
}

int main()
{
    string s;
    cin>>s;
    cin>>k;
    sSize = s.size();
    leftd[0] = 0;
    stack<int> sk;
    int openingBraces = 0;
    if(s[0] == '(')
        openingBraces++;
    for(int i = 0; i < sSize; i++)
    {
        if(s[i]=='(')
        {
            openingBraces ++;
            leftd[i] = leftd[i-1];
            sk.push(i);
        }
        else
        {
            if(openingBraces > 0)
            {
                openingBraces--;
                leftd[i] = leftd[i-1] + 2;
                skoba[i] = sk.top();
                sk.pop();
            }
            else
            {
                leftd[i] = leftd[i-1];
            }
        }
    }
    rightd[sSize-1] = 0;
    int closingBraces = 0;
    if(s[sSize-1] == ')')
        closingBraces++;
    for(int i = sSize-2; i >= 0; i--)
    {
        if(s[i]==')')
        {
            closingBraces ++;
            rightd[i] = rightd[i+1];
        }
        else
        {
            if(closingBraces > 0)
            {
                closingBraces--;
                rightd[i] = rightd[i+1] + 2;
            }
            else
            {
                rightd[i] = rightd[i+1];
            }
        }
    }

    /*

    for(int i = 0; i < sSize; i++)
    {
        cout<<leftd[i] << " - "<< rightd[i]<<endl;
    }
    */

    /// we calculate the maximum number of pairs of braces for each ai and aj
    for(int len = 2; len <= sSize; len++)
    {
        for(int i = 0; i < sSize-(len-1); i++)
        {
            int j = i + (len-1);
            d[i][j] = min((leftd[j]-leftd[i]), (rightd[i]-rightd[j]));
        }
    }

    /*
    for(int i = 0; i < sSize; i++)
    {

        for(int j = 0; j < sSize; j++)
            cout<<d[i][j]<<" ";
        cout<<endl;

    }
    */
    int cuts = d[0][sSize-1]/2;
    k--;

    int resCount = 1;
    int res = (cuts-k)*2;
    cout<<res<<endl;
    for(int i = 0; i < sSize-1; i++)
    {
        if(d[0][i] != d[0][i+1])
        {
            cutHere[cutPoints] = i;
            cutPoints ++;
            //cout<<i<<endl;
        }
    }
    chooseParts(0,res,1,0);
    return 0;
}

/*

(())()(()

*/
