#include <stdio.h>
#include <string.h>
#define MAXN 1000
#define MAXK 200
using namespace std;
char braces[MAXN];
int n, k;
int partsIndexes[MAXK]; //array keeping the index of the first bracket in each part
int globalOptimalSum;

int GetOpenBracketsCount(int first, int last)
{
    int result=0;
    for (int i=first; i<=last; i++)
    {
        if (braces[i]=='(')
        {
            result++;
        }
    }
    return result;
}
int GetMaxSSB(int first, int last)
{
    int openBracketsCount=GetOpenBracketsCount(first, last);
    int needToClose=0;
    for (int i=first; i<=last; i++)
    {
        if (braces[i]=='(')
        {
            needToClose++;
        }
        else if (needToClose>0)
        {
            needToClose--;
        }
    }
    return (openBracketsCount-needToClose)*2;
}

int GetOptimalSum(int first, int byNow, int parts, char o)
{
    if (n-first<parts) return -1;
    if (parts==1)
    {
        return byNow+GetMaxSSB(first, n-1);
    }
    int maxSSB, optimalSum=MAXN, currSum, nextOptimalSum;
    for (int last=first; last<n; last++)
    {
        maxSSB=GetMaxSSB(first, last);
        currSum=byNow+maxSSB;
        nextOptimalSum=GetOptimalSum(last+1, currSum, parts-1, o);
        if (nextOptimalSum==-1) break;
        currSum+=nextOptimalSum;
        if (currSum==globalOptimalSum)
        {
        }
        if (currSum<optimalSum) optimalSum=currSum;
    }
    return optimalSum;
}


int main()
{
    scanf("%s", &braces);
    n=strlen(braces);
    scanf("%d", &k);
    globalOptimalSum=GetOptimalSum(0, 0, k, 'n');
    printf("%d\n", globalOptimalSum);
    return 0;
}

