#include <stdio.h>
#include <vector>
#define MAXN 100000
using namespace std;

int graph[MAXN+1][5];

bool IntInVector(int x, vector<int> vec)
{
    for (int i=0; i<vec.size(); i++)
    {
        if (x==vec[i])
        {
            return true;
        }
    }
    return false;
}

int LongestPathLength(int a, int b, vector<int> visited)
{
    if (a==b) return 0;
    visited.push_back(a);

    int result=-1, currLength;
    for (int i=1; i<=graph[a][0]; i++)
    {
        if (IntInVector(graph[a][i], visited)) continue;
        currLength=LongestPathLength(graph[a][i], b, visited)+1;
        if (currLength>result) result=currLength;
    }
    return result;
}

int main()
{
    int n, m, a, b, u, v;
    scanf("%d%d%d%d", &n, &m, &a, &b);
    for (int i=1; i<=n; i++) graph[i][0]=0;
    for (int i=0; i<m; i++)
    {
        scanf("%d%d", &u, &v);
        graph[u][graph[u][0]+++1]=v;
        graph[v][graph[v][0]+++1]=u;
    }
    vector<int> emptyVector;
    printf("%d\n", LongestPathLength(a, b, emptyVector));
    return 0;
}
