#include <iostream>
#include <string>
#include <vector>
#include <stack>
#include <algorithm>
using namespace std;
const int MAX_K = 200;
const int MAX_N = 1e3 + 24;
int N, K, a[MAX_K], reald[MAX_K], realc[MAX_K], ans;
vector <int> vreald[MAX_N], vind[MAX_N], len[MAX_N], vrealc[MAX_N];
string s;
stack <int> st;
void solvep()
{
    a[K + 1] = N;
    int curans = 0;
    for(int j = 1; j <= K + 1; ++ j)
    {
        for(int i = a[j - 1]; i < a[j]; ++ i)
        {
            if(s[i] == '(')   st.push(i + 1);
            else
            {
                if(!st.empty())
                {
                    int cu = st.top();
                    st.pop();
                    curans += 2;
                    vind[j].push_back(cu);
                    vind[j].push_back(i + 1);
                }
            }
        }
        while(!st.empty())   st.pop();
    }
    if(curans < ans)
    {
        ans = curans;
        for(int i = 1; i <= K + 1; ++ i)
        {
            vreald[i].clear();
            vrealc[i].clear();
            reald[i] = a[i];
            realc[i] = a[i];
            vreald[i] = vind[i];
            vrealc[i] = vind[i];
        }
    }
    else if(curans == ans)
    {
        for(int i = K + 1; i >= 1; -- i)
        {
            if(vind[i].size() > vreald[i].size())
            {
                for(int j = 1; j <= K + 1; ++ j)
                {
                    reald[j] = a[j];
                    vreald[j].clear();
                    vreald[j] = vind[j];
                }
                break;
            }
            else if(vind[i].size() < vreald[i].size())   break;
        }
        for(int i = K + 1; i >= 1; -- i)
        {
            if(vind[i].size() < vrealc[i].size())
            {
                for(int j = 1; j <= K + 1; ++ j)
                {
                    realc[j] = a[j];
                    vrealc[j].clear();
                    vrealc[j] = vind[j];
                }
                break;
            }
            else if(vind[i].size() > vrealc[i].size())   break;
        }
    }
    for(int i = 1; i <= K + 1; ++ i)   vind[i].clear();
}
void solve(int curr, int pr)
{
    if(curr > K)
    {
        solvep();
        return;
    }
    for(int i = pr + 1; i < N; ++ i)
    {
        a[curr] = i;
        solve(curr + 1, i);
    }
}
int main()
{
    cin >> s >> K;
    -- K;
    N = s.size();
    ans = N + K + 10;
    solve(1, 0);
    cout << ans << "\n";
    for(int i = 1; i <= K + 1; ++ i)
    {
        cout << i << ",[" << reald[i - 1] + 1 << "," << reald[i] << "]," << vreald[i].size() << ":";
        sort(vreald[i].begin(), vreald[i].end());
        for(int j = 0; j < vreald[i].size(); ++ j)   cout << vreald[i][j] << " ";
        cout << "\n";
    }
    for(int i = 1; i <= K + 1; ++ i)
    {
        cout << i << ",[" << realc[i - 1] + 1 << "," << realc[i] << "]," << vrealc[i].size() << ":";
        sort(vrealc[i].begin(), vrealc[i].end());
        for(int j = 0; j < vrealc[i].size(); ++ j)   cout << vrealc[i][j] << " ";
        cout << "\n";
    }
    return 0;
}
