#include <iostream>
#include <vector>
#include <cstdio>
#include <cstdlib>
using namespace std;

int n, m, a, b;
vector<vector<int>> gr;

void read()
{
    cin>>n>>m>>a>>b;
    gr.resize(n+1);
    for(int i=0;i<m;i++)
    {
        int x, y;
        cin>>x>>y;
        gr[x].push_back(y);
        gr[y].push_back(x);
    }
}

int answer = 0;
vector<bool> used;
void go(int current, int len)
{
    //printf("  %d %d\n", current, len);
    if(current == b)
    {
        answer = max(answer, len);
        return;
    }

    for(int next : gr[current])
    {
        if(!used[next])
        {
            used[next] = true;
            go(next, len+1);
            used[next] = false;
        }
    }
}

void solve()
{
    used.resize(n+1, false);
    used[a] = true;
    go(a, 0);
    printf("%d\n", answer);
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    read();
    solve();
}
/**
10 12 2 5
1 10
10 9
9 8
8 7
7 6
6 5
5 4
4 6
6 10
10 3
3 2
2 1
**/
