#include <iostream>
#include <vector>
#include <cstdint>

using namespace std;

uint32_t a, b;

struct edge
{
    uint32_t u, v;
};

vector < vector < uint32_t > > ss;
vector < edge > edges;
vector < bool > used;

inline uint32_t get_next (uint32_t cur, uint32_t e)
{
    if(edges[e].u==cur)return edges[e].v;
    return edges[e].u;
}

void init()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    uint32_t n, m;
    cin>>n>>m>>a>>b;
    a--;
    b--;
    ss.resize(n);
    edges.resize(m);
    used.resize(n);
    used[a]=true;
    for(uint32_t i=0; i<m; i++)
    {
        uint32_t u, v;
        cin>>u>>v;
        u--; v--;
        edges[i]={u, v};
        ss[u].push_back(i);
        ss[v].push_back(i);
    }
}

uint32_t res=0;

void rec (uint32_t cur=a, uint32_t cur_br=0)
{
    if(cur==b)
    {

        if(cur_br>res)
            res=cur_br;

        return;
    }

    for(uint32_t i=0; i<ss[cur].size(); i++)
    {
        uint32_t next=get_next(cur, ss[cur][i]);
        if(used[next])continue;
        used[next]=true;
        rec(next, cur_br+1);
        used[next]=false;
    }
}

int main()
{
    init();
    rec();
    cout<<res<<endl;

    return 0;
}
