# include <cstdio>
# include <cstdlib>
# include <vector>

using namespace std;

const int MAX_N = 1e5 + 10;

int n, m, a, b;

vector <int> v[MAX_N];

int in[MAX_N], ou[MAX_N], tin;

void dfs (int x)
{
	in[x] = ++ tin;
	for (int i = 0; i < (int) v[x].size (); i ++)
		if (!in[v[x][i]])
			dfs (v[x][i]);
	ou[x] = tin;
}

int last;
int st;

pair <int, int> walk (int x, int par, int ti)
{

	///printf ("-- %d %d %d - %d %d %d\n", x, par, ti);
	
	if (x == b)
	{
		last = b;
		return {ti, par};
	}
	
	if (x != st && v[x].size () > 2 && in[x] <= in[b] && in[b] <= ou[x])
	{
		last = x;
		return {ti, par};
	}
	
	pair <int, int> crr = {-1, -1};

	for (int i = 0; crr.first == -1 && i < (int) v[x].size (); i ++)
		if (v[x][i] != par && v[x][i] != st)
			crr = walk (v[x][i], x, ti + 1);
	return crr;
}

int go (int x, int par1, int par2)
{
	int ans_sum = 0;
	while (x != b)
	{
		if (x == -1)
		{
			printf ("yoyo\n");
			exit (0);
		}
		
		///printf ("-- %d = %d %d %d\n", ans_sum, x, par1, par2);

		pair <int, int> crr;
		pair <int, int> ansl = {-1, -1}, ansr;
	
		int to = -1;
	
		for (int i = 0; i < (int) v[x].size (); i ++)
		{
			if (v[x][i] == par1 || v[x][i] == par2)
				continue;
			
			///printf ("== %d\n", v[x][i]);
			last = -1;
			st = x;
			crr = walk (v[x][i], x, 1);
			///printf ("%d %d %d\n", last, crr.first, crr.second);
			if (crr.first != -1 && last != -1)
			{
				ansr = ansl;
				ansl = crr;
				to = last;	
			}
		}
	
		
		///printf ("%d %d %d %d %d\n", to, ansl.first, ansl.second, ansr.first, ansr.second);
	
		
	
		if (ansl < ansr)
			ans_sum += ansr.first;
		else
			ans_sum += ansl.first;
		
		x = to;
		par1 = ansl.second;
		par2 = ansr.second;
	
	}
	return ans_sum;
}

int main ()
{
	int p, q, i, j;
	scanf ("%d%d%d%d", &n, &m, &a, &b);
	
	for (i = 0; i < m; i ++)
	{
		scanf ("%d%d", &p, &q);
		v[p].push_back (q);
		v[q].push_back (p);
	}
	
	dfs (a);
	
	///for (i = 1; i <= n; i ++)
	///	printf ("%d %d %d\n", i, in[i], ou[i]);
	
	printf ("%d\n", go (a, -1, -1));
	

	
	return 0;
}

