# include <cstdio>
# include <cstring>
# include <vector>
# include <algorithm>

using namespace std;

const int MAX_N = 1024;
const int MAX_K = 256;

int n, k;

char c[MAX_N];

int dp[MAX_N][MAX_K];
int re[2][MAX_N][MAX_K];

int a[MAX_N];

void print (int l, int r)
{
	int i;
	
	vector <int> v, ans;
	
	for (i = l; i <= r; i ++)
	{
		if (c[i] == '(')
			v.push_back (i);
		else
		{
			if (v.size ())
			{
				ans.push_back (v[v.size () - 1]);
				ans.push_back (i);
				v.pop_back ();
			}
		}
	}
	
	sort  (ans.begin (), ans.end ());
	
	printf ("%d:", (int) ans.size ());
	for (i = 0; i < (int) ans.size (); i ++)
		printf ("%d ", ans[i]);
}

int main ()
{
	int i, j, t, p;
	scanf ("%s", c + 1);
	scanf ("%d", &k);
	
	n = strlen (c + 1);
	
	
	for (i = n; i >= 1; i --)
	{
		int c_ans = 0, cnt = 0;
		
		if (c[i] == '(')
			cnt ++;
		
		for (t = 1; t <= k; t ++)
		{
			dp[i][t] = (1 << 30);
			re[0][i][t] = -1;
			re[1][i][t] = -1;
		}
		
		for (j = i + 1; j <= n; j ++)
		{
			for (t = 2; j + t - 2 <= n; t ++)
			{
				
				p = dp[j][t - 1] + c_ans;
				
				///printf ("%d %d %d %d - %d\n", i, j, t, p, dp[i][t]);
				
				if (p < dp[i][t])
				{
					dp[i][t] = p;
					re[0][i][t] = re[1][i][t] = j - 1;
				}
				else
					if (p == dp[i][t])
						re[0][i][t] = j - 1;
			}
		
			if (c[j] == '(')
				cnt ++;
			else
				if (cnt)
				{
					cnt --;
					c_ans ++;
				}
		}
		
		dp[i][1] = c_ans;
		re[0][i][1] = n;
		re[1][i][1] = n;
	}
	
	printf ("%d\n", dp[1][k] * 2);
	
	int x;
	
	for (x = 1, i = 1; i <= k; i ++)
	{
		printf ("%d,[%d,%d],", i, x, re[1][x][k - i + 1]);
		print (x, re[1][x][k - i + 1]);
		printf ("\n");
		
		x = re[1][x][k - i + 1] + 1;
	}
	
	for (x = 1, i = 1; i <= k; i ++)
	{
		printf ("%d,[%d,%d],", i, x, re[0][x][k - i + 1]);
		print (x, re[0][x][k - i + 1]);
		printf ("\n");
		
		x = re[0][x][k - i + 1] + 1;
	}
	
	return 0;
}

