#include<iostream>
#include<cstring>
#include<vector>
#include<queue>

using namespace std;

const int MAXN = 1e5 + 5;

int n, m, A, B;
int u, v;

bool used[MAXN];
vector <int> graph[MAXN];

int answer = 0;
int dp[MAXN];

void DFS(int x, int dist)
{
    if(x==B)
    {
        answer = max(answer, dist);
        return;
    }
    used[x] = true;

    for(int i = 0;i<graph[x].size();i++)
    {
        if(used[ graph[x][i] ]==false)
        {
            DFS(graph[x][i], dist+1);
        }
    }

    used[x] = false;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n >> m >> A >> B;
    for(int i = 0;i<m;i++)
    {
        cin >> u >> v;

        graph[u].push_back(v);
        graph[v].push_back(u);
    }

    for(int i = 1;i<=n;i++)
        dp[i] = -1;

    DFS(A, 0);
    cout << answer << '\n';
}
/*
10 12 2 5
1 10
10 9
9 8
8 7
7 6
6 5
5 4
4 6
6 10
10 3
3 2
2 1
*/
