#include<iostream>
#include<vector>
#include<climits>
#include<algorithm>
#include<stack>
#include<queue>
using namespace std;

vector<vector<int>> ids;

void gen(int needed, int cur, int n, vector<int> v)
{
    if(v.size()==needed)
    {
        ids.push_back(v);
        return ;
    }
    for(int i=cur;i<=n;i++)
    {
        v.push_back(i);
        gen(needed, i+1,n, v);
        v.pop_back();
    }
}

void printIDs(string s, int start, int end)
{
    string cur=s.substr(start-1, end-start+1);
    stack<int> st;
    priority_queue<int> p;
    int cnt=0;
    for(int i=start; i<=end; i++)
    {
        if(cur[cnt++]=='(')
        {
            st.push(i);
        }
        else
        {
            if(!st.empty())
            {
                int x=st.top();
                st.pop();
                p.push(-x);
                p.push(-i);
            }
        }
    }
    while(!p.empty())
    {
        int x=-p.top();
        p.pop();
        cout<<x<<" ";
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    string s;
    int k;
    cin>>s>>k;
    vector<vector<int>>v;
    int n=s.size();
    v.resize(n+1, vector<int>(n+1));
    for(int i=1;i<=n;i++)
    {
        int cnt=0;
        if(s[i-1]=='(')cnt++;
        for(int j=i+1;j<=n;j++)
        {
            if(s[j-1]==')')
            {
                if(cnt>0)
                {
                    cnt--;
                    v[i][j]=v[i][j-1]+2;
                }
                else
                {
                    v[i][j]=v[i][j-1];
                }
            }
            else
            {
                v[i][j]=v[i][j-1];
                cnt++;
            }
        }
    }
    vector<int> vec;
    gen(k-1,1,n-1,vec);
    int minAns=INT_MAX;
    vector<int>firstIDs, secondIDs;
    for(vector<int> vect : ids)
    {
        int ans=v[1][vect[0]];
        for(int i=1;i<vect.size();i++)
        {
            ans+=v[vect[i-1]+1][vect[i]];
        }
        ans+=v[vect[vect.size()-1]+1][n];
        //cout<<ans<<endl;
        if(ans<minAns)
        {
            minAns=ans;
            firstIDs=vect;
        }
    }
    for(vector<int> vect : ids)
    {
        int ans=v[1][vect[0]];
        for(int i=1;i<vect.size();i++)
        {
            ans+=v[vect[i-1]+1][vect[i]];
        }
        ans+=v[vect[vect.size()-1]+1][n];
        //cout<<ans<<endl;
        if(ans==minAns)
        {
            minAns=ans;
            secondIDs=vect;
        }
    }
    cout<<minAns<<endl;
    if(secondIDs.empty())
    {
        secondIDs=firstIDs;
    }
    int cnt=1;
    cout<<cnt<<",["<<"1"<<","<<firstIDs[0]<<"],"<<v[1][firstIDs[0]]<<":";
    printIDs(s, 1, firstIDs[0]);
    cout<<endl;
    for(int i=1;i<firstIDs.size();i++)
    {
        cnt++;
        cout<<cnt<<",["<<firstIDs[i-1]+1<<","<<firstIDs[i]<<"],"<<v[firstIDs[i-1]+1][firstIDs[i]]<<":";
        printIDs(s, firstIDs[i-1]+1, firstIDs[i]);
        cout<<endl;
    }
    cnt++;
    cout<<cnt<<",["<<firstIDs[firstIDs.size()-1]+1<<","<<n<<"],"<<v[firstIDs[firstIDs.size()-1]+1][n]<<":";
    printIDs(s,firstIDs[firstIDs.size()-1]+1, n);
    cout<<endl;



    cnt=1;
    cout<<cnt<<",["<<"1"<<","<<secondIDs[0]<<"],"<<v[1][secondIDs[0]]<<":";
    printIDs(s, 1, secondIDs[0]);
    cout<<endl;
    for(int i=1;i<secondIDs.size();i++)
    {
        cnt++;
        cout<<cnt<<",["<<secondIDs[i-1]+1<<","<<secondIDs[i]<<"],"<<v[secondIDs[i-1]+1][secondIDs[i]]<<":";
        printIDs(s, secondIDs[i-1]+1, secondIDs[i]);
        cout<<endl;
    }
    cnt++;
    cout<<cnt<<",["<<secondIDs[secondIDs.size()-1]+1<<","<<n<<"],"<<v[secondIDs[secondIDs.size()-1]+1][n]<<":";
    printIDs(s,secondIDs[secondIDs.size()-1]+1, n);

    cout<<endl;
    return 0;
}
