#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int MAX_N = 1005;
const int MAX_K = 205;

bool isCalculated[MAX_N][MAX_K];
int n, maxSubseq[MAX_N][MAX_N], dp[MAX_N][MAX_K];

int ComputeDp(int ind, int rem) {
	if(rem == 0) {
		if(ind != n) {
			return -1;
		}
		else {
			return 0;
		}
	}
	else if(ind == n) {
		return -1;
	}
	else if(isCalculated[ind][rem]) {
		return dp[ind][rem];
	}

	int bestAns = -1;
	for(int i = ind; i < n; i++) {
		int currAns = ComputeDp(i + 1, rem - 1);
		if(currAns == -1) {
			continue;
		}

		currAns += maxSubseq[ind][i];

		if(bestAns == -1 || currAns < bestAns) {
			bestAns = currAns;
		}
	}

	isCalculated[ind][rem] = true;
	dp[ind][rem] = bestAns;

	return bestAns;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	int k;
	string s;
	
	cin >> s >> k;

	n = s.size();
	for(int i = 0; i < n; i++) {
		int cntRemOpening = 0, maxLen = 0;

		for(int j = i; j < n; j++) {
			if(s[j] == '(') {
				cntRemOpening++;
			}
			else {
				if(cntRemOpening > 0) {
					maxLen++;
					cntRemOpening--;
				}
			}

			maxSubseq[i][j] = maxLen;
		}
	}

	int ans = 2 * ComputeDp(0, k);
	cout << ans << endl;

	return 0;
}
