#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int MAX_N = 1005;
const int MAX_K = 205;

bool isCalculated[MAX_N][MAX_K];
int n, k, maxSubseq[MAX_N][MAX_N], dp[MAX_N][MAX_K];

void ComputeDp() {
	memset(dp, -1, sizeof(dp));

	dp[n][0] = 0;
	for(int j = 1; j <= k; j++) {
		for(int i = n - 1; i >= 0; i--) {
			for(int p = i; p < n; p++) {
				int curr = dp[p + 1][j - 1];
				if(curr == -1) {
					continue;
				}
				curr += maxSubseq[i][p];

				if(dp[i][j] == -1 || curr < dp[i][j]) {
					dp[i][j] = curr;
				}
			}
		}
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	string s;
	cin >> s >> k;

	n = s.size();
	for(int i = 0; i < n; i++) {
		int cntRemOpening = 0, maxLen = 0;

		for(int j = i; j < n; j++) {
			if(s[j] == '(') {
				cntRemOpening++;
			}
			else {
				if(cntRemOpening > 0) {
					maxLen++;
					cntRemOpening--;
				}
			}

			maxSubseq[i][j] = maxLen;
		}
	}
	
	ComputeDp();

	int ans = 2 * dp[0][k];
	cout << ans << endl;

	return 0;
}
