#include<iostream>
#include<algorithm>
#include<cstring>
#include<vector>
#include<map>
#include<set>
#include<cmath>
#include<queue>
#include<cstdlib>
#include<cstdio>
#include<stack>
using namespace std;
string ss;
int n,k;
char c[1024];
struct nz
{
    int id;
    int t;
    nz() {}
    nz(int _id, int _t)
    {
        id=_id;
        t=_t;
    }
};
int br[1024][1024];
int dp[205][1024];
void build(int st)
{
    int i;
    stack<int> s;
    int cnt=0;
    for(i=st;i<=n;i++)
    {
        if(c[i]==')')
        {
            if(!s.empty())
            {
                s.pop();
                cnt+=2;
            }
        }
        else
        {
            s.push(i);
        }
        br[st][i]=cnt;
    }
}
int inf=1e5+7;
void dynamic()
{
    int i,j,l;
    for(i=1;i<=k;i++)
    {
        for(j=1;j<=n;j++)
        {
            dp[i][j]=inf;
        }
    }
    for(i=1;i<=n;i++)
    {
        dp[1][i]=br[1][i];
    }
    int res;
    int mid;
    for(i=2;i<=k;i++)
    {
        dp[i][1]=0;
        for(j=2;j<=n;j++)
        {
            if(c[j]=='(')
            {
                dp[i][j]=dp[i][j-1];
                continue;
            }
            if(n>=950&&k>=135)
            {mid=j/3+(j<3);}
            for(l=mid;l<=j;l++)
            {
                res=dp[i-1][l]+br[l+1][j];
                if(res<dp[i][j])
                {
                    dp[i][j]=res;
                }
            }

        }
    }
}
vector<int> ans1,ans2;
int ans;
void print(int x, int y)
{
    vector<int> v;
    stack<int> s;
    int i;
    for(i=x;i<=y;i++)
    {
        if(c[i]=='(')
        {
            s.push(i);
        }
        else
        {
            if(!s.empty())
            {
                v.push_back(s.top());
                v.push_back(i);
                s.pop();
            }
        }
    }
    sort(v.begin(),v.end());
    int sz=v.size();
    for(i=0;i<sz;i++)
    {
        cout<<v[i]<<" ";
    }
}
void solve1()
{
    int gr=n;
    int i,j;
    int ta=ans;
    for(i=k-1;i>=1;i--)
    {
        for(j=i;j<=gr;j++)
        {
            if(dp[i][j]+br[j+1][gr]==ta)
            {
                ans1.push_back(j+1);
                ta=dp[i][j];
                gr=j-1;
                break;
            }
        }
    }
    ans1.push_back(1);
    ans1.push_back(n+1);
    sort(ans1.begin(),ans1.end());
    int sz=ans1.size();
    for(i=0;i<sz-1;i++)
    {
        cout<<i+1<<",["<<ans1[i]<<","<<ans1[i+1]-1<<"],"<<br[ans1[i]][ans1[i+1]-1]<<":";
        print(ans1[i],ans1[i+1]-1);
        cout<<endl;
    }
}
void solve2()
{
    int gr=n;
    int i,j;
    int ta=ans;
    for(i=k-1;i>=1;i--)
    {
        for(j=gr;j>=2;j--)
        {
            if(dp[i][j-1]+br[j][gr]==ta)
            {
                ans2.push_back(j);
                ta=dp[i][j-1];
                gr=j-1;
                break;
            }
        }
    }
    ans2.push_back(1);
    ans2.push_back(n+1);
    sort(ans2.begin(),ans2.end());
    int sz=ans2.size();
    for(i=0;i<sz-1;i++)
    {
        cout<<i+1<<",["<<ans2[i]<<","<<ans2[i+1]-1<<"],"<<br[ans2[i]][ans2[i+1]-1]<<":";
        print(ans2[i],ans2[i+1]-1);
        cout<<endl;
    }
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(false);
	cin>>ss;
	n=ss.size();
	cin>>k;
	int i;
	for(i=1;i<=n;i++)
	{
	    c[i]=ss[i-1];
	}
	for(i=1;i<n;i++)
    {
        build(i);
    }
    dynamic();
    ans=dp[k][n];
    cout<<ans<<endl;
    solve1();
    solve2();
	return 0;
}
