#include <iostream>
#include <vector>
#include <cstdio>
#include <queue>
#define N 100001
using namespace std;
vector <int> g[N];
int n,u,v,ans=0;
int pprev[N], p[N];

void findp(int vv1,int vv2)
{
    int pr,v1=vv1,v2=vv2;
    while(1)
    {
        if(pprev[v1]==pprev[v2])
            {pr = pprev[v1]; break;}
        if(pprev[v1]==v2)
            {pr = v2; break;}
        if(pprev[v2]==v1)
            {pr = v1; break;}
        v2=pprev[v2];
        v1=pprev[v1];
    }
    v1=vv1,v2=vv2;
    while(v1!=pr) p[v1]=pr, v1=pprev[v1];
    while(v2!=pr) p[v2]=pr, v2=pprev[v2];
}

void bfs()
{
    queue<int> q;
    q.push(u);
    pprev[u]=-1;
    while(!q.empty())
    {
        int v1=q.front();
        q.pop();
        //cout<<v1<<endl;
        for(int v2:g[v1])
        {
            if(v2!=pprev[v1])
                if(pprev[v2]==0)
                    pprev[v2]=v1, q.push(v2);
                else if(p[v1]==0)
                    findp(v1,v2);
        }
    }
}

int path;
void findpath(int vr,int put=0,int pred=-1)
{
    if(vr==p[v])
        path=max(path,put);
    else
        for(int v2: g[vr])
        {
            if(v2!=pred && ( p[v2]==p[v] || v2==p[v] ))
                findpath(v2,put+1,vr);
        }
}

void solve()
{
   // for(int i=1; i<=n; i++) cout<<i<<" "<<p[i]<< endl;
    while(v!=u)
    {
        path=0;
        findpath(v);
        v=p[v];
        ans+=path;
    }
    cout<<ans<< endl;
}

int main()
{
    int m,i,a,b;
    cin>>n>>m>>u>>v;
    for(i=0; i<m; i++)
    {
        scanf("%i%i",&a,&b);
        g[a].push_back(b);
        g[b].push_back(a);
    }
    bfs();
    solve();
    return 0;
}
/*
10 12 2 5
1 10
10 9
9 8
8 7
7 6
6 5
5 4
4 6
6 10
10 3
3 2
2 1
*/
