#include<iostream>
#include<vector>
using namespace std;
vector<int> susediI[100001];
vector<int> susedi[100001];
vector<int> weight[100001];
int dist[100001],ans=0,ender;
void dfs(int v){
	if(v==ender){
		ans=max(ans,dist[v]);
		return;
	}
	for(int i=0;i<susedi[v].size();i++){
		if(dist[susedi[v][i]]==0){
			dist[susedi[v][i]]=dist[v]+weight[v][i];
			dfs(susedi[v][i]);
			dist[susedi[v][i]]=0;
		}
	}
}
pair<int,int> forward(int ind,int v){
	pair<int,int> nextV={susediI[v][ind],1};
	int from=v;
	while(susediI[nextV.first].size()==2&&nextV.first!=v){
		nextV.second++;
		int nextInd=0;
		if(susediI[nextV.first][0]==from){
			nextInd++;
		}
		from=nextV.first;
		nextV.first=susediI[nextV.first][nextInd];
	}
	return nextV;
}
int main(){
	cin.tie(NULL);
	ios::sync_with_stdio(false);
	int n,m,begA,endB;
	cin>>n>>m>>begA>>endB;
	int a,b;
	for(int i=0;i<m;i++){
		cin>>a>>b;
		susediI[a].push_back(b);
		susediI[b].push_back(a);
	}
	for(int i=1;i<=n;i++){
		for(int j=0;j<susediI[i].size();j++){
			pair<int,int> next=forward(j,i);
			susedi[i].push_back(next.first);
			weight[i].push_back(next.second);
		}
	}
	
	vector<pair<int,int>> begs,ends;
	if(susediI[begA].size()==2){
		begs.push_back(forward(0,begA));
		begs.push_back(forward(1,begA));
	}else{
		begs.push_back({begA,0});
	}
	if(susediI[endB].size()==2){
		ends.push_back(forward(0,endB));
		ends.push_back(forward(1,endB));
	}else{
		ends.push_back({endB,0});
	}
	int fans=0;
	for(int i=0;i<begs.size();i++){
		for(int j=0;j<ends.size();j++){
			ans=0;
			dist[begs[i].first]=1;
			ender=ends[j].first;
			dfs(begs[i].first);
			fans=max(fans,ans+begs[i].second+ends[j].second);
			dist[begs[i].first]=0;
		}
	}
	cout<<fans-1<<"\n";
	return 0;
}

