#include<iostream>
#include<vector>
using namespace std;
vector<int> susediI[100001];
vector<int> susedi[100001];
vector<int> weight[100001];
int dist[100001],ans=0,begA,endB;
void dfs(int v){
	if(v==endB){
		ans=max(ans,dist[v]);
		return;
	}
	for(int i=0;i<susedi[v].size();i++){
		if(dist[susedi[v][i]]==0){
			dist[susedi[v][i]]=dist[v]+weight[v][i];
			dfs(susedi[v][i]);
			dist[susedi[v][i]]=0;
		}
	}
}
pair<int,int> forward(int ind,int v){
	pair<int,int> nextV={susediI[v][ind],1};
	int from=v;
	while(susediI[nextV.first].size()==2&&nextV.first!=v&&nextV.first!=begA&&nextV.first!=endB){
		nextV.second++;
		int nextInd=0;
		if(susediI[nextV.first][0]==from){
			nextInd++;
		}
		from=nextV.first;
		nextV.first=susediI[nextV.first][nextInd];
	}
	return nextV;
}
int main(){
	cin.tie(NULL);
	ios::sync_with_stdio(false);
	int n,m;
	cin>>n>>m>>begA>>endB;
	int a,b;
	for(int i=0;i<m;i++){
		cin>>a>>b;
		susediI[a].push_back(b);
		susediI[b].push_back(a);
	}
	for(int i=1;i<=n;i++){
		for(int j=0;j<susediI[i].size();j++){
			pair<int,int> next=forward(j,i);
			if(next.first==i) continue;
			susedi[i].push_back(next.first);
			weight[i].push_back(next.second);
		}
	}
	dist[begA]=1;
	dfs(begA);
	cout<<ans-1<<"\n";
	return 0;
}

