#include<iostream>
#include<vector>
using namespace std;
int malInd=0;
vector<int> susedi[2][100001];
vector<int> weight[2][100001];
int dist[100001],ans=0,begA,endB;
void dfs(int v){
	if(v==endB){
		ans=max(ans,dist[v]);
		return;
	}
	for(int i=0;i<susedi[malInd][v].size();i++){
		if(dist[susedi[malInd][v][i]]==0){
			dist[susedi[malInd][v][i]]=dist[v]+weight[malInd][v][i];
			dfs(susedi[malInd][v][i]);
			dist[susedi[malInd][v][i]]=0;
		}
	}
}
pair<int,int> forward(int ind,int v){
	pair<int,int> nextV={susedi[malInd^1][v][ind],weight[malInd^1][v][ind]};
	int from=v;
	while(susedi[malInd^1][nextV.first].size()==2&&nextV.first!=v&&nextV.first!=begA&&nextV.first!=endB){
		int nextInd=0;
		if(susedi[malInd^1][nextV.first][0]==from) nextInd++;
		from=nextV.first;
		nextV.second+=weight[malInd^1][nextV.first][nextInd];
		nextV.first=susedi[malInd^1][nextV.first][nextInd];
	}
	return nextV;
}
int main(){
	cin.tie(NULL);
	ios::sync_with_stdio(false);
	int n,m;
	cin>>n>>m>>begA>>endB;
	int a,b;
	for(int i=0;i<m;i++){
		cin>>a>>b;
		susedi[malInd][a].push_back(b);
		susedi[malInd][b].push_back(a);
		weight[malInd][a].push_back(1);
		weight[malInd][b].push_back(1);
	}
	for(int p=0;p<3;p++){
		malInd^=1;
		for(int i=1;i<=n;i++){
			susedi[malInd][i].clear();
			weight[malInd][i].clear();
			for(int j=0;j<susedi[malInd^1][i].size();j++){
				pair<int,int> next=forward(j,i);
				if(next.first==i) continue;
				susedi[malInd][i].push_back(next.first);
				weight[malInd][i].push_back(next.second);
			}
		}
	}
	dist[begA]=1;
	dfs(begA);
	cout<<ans-1<<"\n";
	return 0;
}

