#include<iostream>
#include<algorithm>
#include<deque>
#include<ctime>
using namespace std;
struct bug{
	int x,y,num;
}bugs[1005];
bool operator<(bug a,bug b){
	return a.y<b.y;
}
int n;
int orient(bug a,bug b,bug c){
	b.x-=a.x;
	c.x-=a.x;
	b.y-=a.y;
	c.y-=a.y;
	return b.x*c.y-b.y*c.x;
}
bool sortConvex(bug b,bug c){
	return orient(bugs[0],b,c)>0;
}
bool sortOrderly(bug a,bug b){
	return a.num<b.num;
}
bool checkA(){
	sort(bugs,bugs+n,sortOrderly);
	for(int i=2;i<n;i++){
		if(orient(bugs[i-2],bugs[i-1],bugs[i])<0) return false;
	}
}
bool checkB(){
	sort(bugs,bugs+n,sortOrderly);
	for(int i=2;i<n;i++){
		if(orient(bugs[i-2],bugs[i-1],bugs[i])>0) return false;
	}
}
bool checkC(){
	sort(bugs,bugs+n);
	sort(bugs+1,bugs+n,sortConvex);
	for(int i=2;i<n;i++){
		if(orient(bugs[i-2],bugs[i-1],bugs[i])<0) return false;
	}
	return true;
}
bool foundA=false,foundB=false,foundC=false;
deque<pair<int,int>> moves,ansC,ansB,ansA;
time_t begger;
void rek(){
	time_t currer=time(NULL);
	if(currer-begger>1000){
		if(foundB){
			ansA=ansB;
		}else{
			ansA=ansC;
		}
		foundA=true;
	}
	if(moves.size()>200000) return;
	if(checkA()){
		ansA=moves;
		foundA=true;
		return;
	}
	if(checkB()){
		ansB=moves;
		foundB=true;
		return;
	}
	if(checkC()){
		ansC=moves;
		foundC=true;
	}
	for(int i=0;i<n;i++){
		for(int j=0;j<n;j++){
			if(i==j) continue;
			bug mem=bugs[i];
			bugs[i].x+=(bugs[j].x-bugs[i].x);
			bugs[i].y+=(bugs[j].y-bugs[i].y);
			moves.push_back({bugs[i].num,bugs[j].num});
			rek();
			if(foundA) return;
			moves.pop_back();
			bugs[i]=mem;
		}
	}
}
int main(){
	cin.tie(NULL);
	ios::sync_with_stdio(false);
	begger=time(NULL);
	cin>>n;
	for(int i=0;i<n;i++){
		cin>>bugs[i].x>>bugs[i].y;
		bugs[i].num=i+1;
	}
	rek();
	if(foundA){
		cout<<ansA.size()<<"\n";
		for(auto move:ansA){
			cout<<move.first<<" "<<move.second<<"\n";
		}
	}
	if(!foundA&&!foundB&&!foundC) cout<<"0\n";
	return 0;
}
