#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#define pb push_back
#define mp make_pair
using namespace std;
const int N=1e2+5;

int n;

struct point{

 double x,y;

}p[N];

int orientation(point a,point b,point c)
{
    double cw=(b.y-a.y)*(c.x-b.x) - (c.y-b.y)*(b.x-a.x);

    if(cw > 0) ///clockwise
        return 1;
    if(cw < 0) /// counter_clockwise
        return -1;

    return 0;
}

vector <point> hull;

bool point_sort(point a,point b)
{
    if(orientation(p[0],a,b) > 0)
        return false;
    return true;
}

int main()
{
   int i;

   scanf("%d", &n);
   for(i=0;i<n;i++)
   {
       scanf("%lf%lf", &p[i].x, &p[i].y);
   }
   for(i=1;i<n;i++)
   {
       if(p[i].y < p[0].y)
        swap(p[i],p[0]);
       else
        if(p[i].x < p[0].x)
         swap(p[i],p[0]);
   }

   sort(p+1,p+n,point_sort);

   for(i=0;i<3;i++)
   {
       hull.pb(p[i]);
   }
   for(i=3;i<n;i++)
   {
       point p1,p2;
       p1=hull[(int)hull.size()-2];
       p2=hull[(int)hull.size()-1];
       if(orientation(p1,p2,p[i]) > 0)
       {
           printf("None\n");
           return 0;
       }
       hull.pb(p[i]);
   }

   printf("0\n");


   return 0;
}
