#include<iostream>
#include<stdio.h>
#include<vector>
using namespace std ;

#define MAXN 100007

int n , m ;
int st , en ;
int dp[ MAXN ] ;
vector < int > v[ MAXN ] ;
int used[ MAXN ] ;

void dfs ( int vertex ) {
	used[ vertex ] = 1 ;
	if ( vertex == en ) { dp[ vertex ] = 0 ; return ; }
	int i ;
	int sz = v[ vertex ].size ( ) ;
	for ( i = 0 ; i < sz ; i ++ ) {
		if ( used[ v[ vertex ][ i ] ] == 0 ) {
			dfs ( v[ vertex ][ i ] ) ;
			if ( dp[ vertex ] < dp[ v[ vertex ][ i ] ] + 1 ) {
				dp[ vertex ] = dp[ v[ vertex ][ i ] ] + 1 ;
			}
		}
	}
}


void input ( ) {
	scanf ( "%d%d%d%d" , &n , &m , &st , &en ) ;
	int i ;
	for ( i = 1 ; i <= m ; i ++ ) {
		int x , y ;
		scanf ( "%d%d" , &x , &y ) ;
		v[ x ].push_back ( y ) ;
		v[ y ].push_back ( x ) ;
	}
}

void solve ( ) {
	dfs ( st ) ;
	printf ( "%d\n" , dp[ st ] + 1 ) ;
}

int main ( ) {
	input ( ) ;
	solve ( ) ;
	return 0 ;
}
