#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <stack>
using namespace std;

const int N=105;

struct Point
{
 int x;
 int y;
 int index;
};

Point a[N],b[N];
stack <Point> st;
vector < pair <int,int> > v;

int CrossProduct(Point p,Point q,Point r)
{
 int cp=((q.x-p.x)*(r.y-p.y))-((r.x-p.x)*(q.y-p.y));
 return cp;
}

bool Compare(Point p,Point q)
{
  if(CrossProduct(a[1],p,q)>0)
   return true;

 return false;
}

Point BeforeTop()
{
 Point temp,bt;

 temp=st.top();
 st.pop();
 bt=st.top();
 st.push(temp);
 return bt;
}

int main()
{

int n,i,j,minx,miny,ind,sz,diffx,diffy;

scanf("%d",&n);

miny=2000;
minx=2000;
 for(i=1;i<=n;i++)
 {
  scanf("%d%d",&a[i].x,&a[i].y);

   if((a[i].y<miny) || (a[i].y==miny && a[i].x<minx))
   {
    ind=i;
    miny=a[i].y;
    minx=a[i].x;
   }

  a[i].index=i;
 }

swap(a[1],a[ind]);

 for(i=2;i<=n;i++)
  b[i-1]=a[i];

sort(b+1,b+n,Compare);

 for(i=2;i<=n;i++)
  a[i]=b[i-1];

st.push(a[1]);
st.push(a[2]);
 for(i=3;i<=n;i++)
 {
   if(CrossProduct(BeforeTop(),st.top(),a[i])<0)
   {
    diffx=a[i].x-st.top().x;
    diffy=a[i].y-st.top().y;
    a[i].x=st.top().x-diffx;
    a[i].y=st.top().y-diffy;
    v.push_back(make_pair(a[i].index,st.top().index));
   }

  st.push(a[i]);
 }

sz=v.size();

printf("%d\n",sz);

 for(i=0;i<sz;i++)
  printf("%d %d\n",v[i].first,v[i].second);

return 0;
}
