#include <iostream>
#include <algorithm>
using namespace std;
struct point{
int x,y;
int num;
};
const int maxN=10010;
int n,m;
point p[maxN];
point h[maxN];
int cnt;
void symetric(int i,int j)
{
    int difx,dify;
    difx=p[i].x-p[j].x;
    dify=p[i].y-p[j].y;
    p[n].x=p[i].x+difx;
    p[n].y=p[i].y+dify;
    p[n].num=(i+1)*100+j;
    n++;
}
int ori(point a,point b,point c)
{
    int d=(a.x-b.x)*(a.y-c.y)-(a.y-b.y)*(a.x-c.x);
    if(d==0)return 0;
    if(d<0)return -1;
    return 1;
}
int dist(point a)
{
    return (p[0].x-a.x)*(p[0].x-a.x)+(p[0].y-a.y)*(p[0].y-a.y);
}
bool cmp(point a,point b)
{
    int q=ori(p[0],a,b);
    if(q==0)return dist(a) < dist(b);
    return q>0;
}
void convexHull(point p[],int m)
{
    int i,ind=0;
    for(i=1;i<n;i++)
    {
        if(p[i].x<p[ind].x || (p[i].x==p[ind].x && p[i].y<p[ind].y))ind=i;
    }
    swap(p[0],p[ind]);
    sort(p+1,p+n,cmp);
    h[0]=p[0];
    h[1]=p[1];
    cnt=2;
    for(i=2;i<n;i++)
    {
        while(cnt>=2 && ori(h[cnt-2],h[cnt-1],p[i])<=0)cnt--;
        h[cnt++]=p[i];
    }
}
bool check()
{
    convexHull(p,n);
    if(cnt==n)return 1;
    return 0;
}
int main()
{
    int i,j;
    cin>>n;
    for(i=0;i<n;i++)
    {
        cin>>p[i].x>>p[i].y;
        p[i].num=i+1;
    }
    m=n;
    if(check()==1)
    {
        cout<<0;
        return 0;
    }
    else cout<<"None"<<endl;
    return 0;
    for(i=0;i<m;i++)
    {
        for(j=0;j<m;j++)
        {
            if(i==j)continue;
            symetric(i,j);
        }
    }
    convexHull(p,n);
    return 0;
}
/**
6
3 5
4 3
3 1
11 4
7 7
7 2
*/
