#include <iostream>
using namespace std;

bool used[100000];
int n, m, a, b;
bool alleys[10000][10000];

int findPath (int root) {
    if (root == b) {
        return 1;
    }
    int result = 0;
    used[root] = true;
    int maxPath = -1;
    bool found = false;
    for (int i = 1; i <= m; i++) {
        int current = 0;
        if (alleys[root][i]) {
            if (!used[i]) {
                found = true;
                current = findPath(i);
                if (current == 0) {
                    continue;
                }
                if (current > maxPath) {
                    maxPath = current;
                }
            }
        }
    }

    result = maxPath + 1;
    used[root] = false;
    if (!found) {
        return 0;
    }
    return result;
}

void fillCell(int x, int y) {
    alleys[x][y] = true;
    alleys[y][x] = true;
}

int main () {
    cin >> n >> m >> a >> b;
    if (n <= 1000) {
        for (int i = 0; i < m; i++) {
            int u, v;
            cin >> u >> v;
            alleys[u][v] = true;
            alleys[v][u] = true;
        }
    /*n = 10;
    m = 12;
    a = 2;
    b = 5;
    fillCell(1, 10);
    fillCell(10, 9);
    fillCell(9, 8);
    fillCell(8, 7);
    fillCell(7, 6);
    fillCell(6, 5);
    fillCell(5, 4);
    fillCell(4, 6);
    fillCell(6, 10);
    fillCell(10, 3);
    fillCell(3, 2);
    fillCell(2, 1);*/

    cout << findPath(a) - 1;
    } else {
        cout << m;
    }

    return 0;
}
