#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int N = 100007;

int n,m,a,b;
vector < int > v[N];
vector < int > g[N*2];
bool used[N*2];
vector < vector < int > > cycles;
bool in[N];
vector < int > st;
int found;
int cnt[N];
map < pair < int, int >, int > idx;
int path[N*2],path_sz;
int from[N*2];
int ans;

void get_cycle(int what) {
    vector < int > curr;
    int posa=-1,posb=-1,i;

    for(i=(int)(st.size())-1;i>=0;i--) {
        if(st[i]==a) posa=(int)(curr.size());
        if(st[i]==b) posb=(int)(curr.size());

        ++cnt[st[i]];
        curr.push_back(st[i]);
        if(st[i]==what) break;
    }

    if(posa!=-1 && posb!=-1) {
        found=max(abs(posa-posb),(int)(curr.size())-abs(posa-posb));
    }

    cycles.push_back(curr);
}

int get_dist(int a, int b, int which) {
    int posa=idx[make_pair(a,which)],posb=idx[make_pair(b,which)];
    return max(abs(posa-posb),(int)(cycles[which].size())-abs(posa-posb));
}

void dfsv(int node, int from=-1) {
    used[node]=true;
    in[node]=true;
    st.push_back(node);

    int i;

    for(i=0;i<(int)(v[node].size());i++) if(v[node][i]!=from) {
        if(used[v[node][i]]) {
            if(in[v[node][i]]) {
                get_cycle(v[node][i]);
            }
        }
        else {
            dfsv(v[node][i],node);
        }
    }

    in[node]=false;
    st.pop_back();
}

void dfsg(int node) {
    used[node]=true;

    int i;
    
    for(i=0;i<(int)(g[node].size());i++) if(!used[g[node][i]]) {
        from[g[node][i]]=node;
        dfsg(g[node][i]);
    }
}

void add_edge(int x, int y) {
    g[x].push_back(y);
    g[y].push_back(x);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int i,j,z,x,y;

    scanf("%d %d %d %d", &n, &m, &a, &b);
    for(i=1;i<=m;i++) {
        scanf("%d %d", &x, &y);
        v[x].push_back(y);
        v[y].push_back(x);
    }

    found=-1;
    dfsv(a);

    if(found!=-1) {
        printf("%d\n", found);
        return 0;
    }

    for(i=0;i<(int)(cycles.size());i++) {
        for(j=0;j<(int)(cycles[i].size());j++) {
            add_edge(cycles[i][j],n+1+i);
            idx[make_pair(cycles[i][j],i)]=j;
        }
    }

    memset(used,0,sizeof(used));
    dfsg(a);
    while(b!=a) {
        path[++path_sz]=b;
        b=from[b];
    }
    path[++path_sz]=b;
    for(i=2;i<=path_sz;i+=2) ans+=get_dist(path[i-1],path[i+1],path[i]-n-1);
    printf("%d\n", ans);

    return 0;
}
