#include<iostream>
#include<vector>
#include<queue>
using namespace std;
int n, m, a, b;
vector <int> grid[100001];
int path[100001];
int used[100001];
struct node{
    int from;
    int to;
    int pos;
};
operator<(node a, node b){
    return a.pos>b.pos;
}
void dijkstra(int a,int b){
    queue <node> qu;
    for(int i=0;i<grid[a].size();i++){
        node x;
        x.from = a;
        x.to = grid[a][i];
        x.pos = grid[i].size();
        qu.push(x);
        path[grid[a][i]] = max(path[grid[a][i]],path[a]+1);
    }
    //cout<<endl;
    used[a] = 1;
    while(!qu.empty()){
        node x;
        x = qu.front();
        qu.pop();
        used[x.from] = 1;
        for(int i=0;i<grid[x.to].size();i++){
            if(!used[grid[x.to][i]]){
                node r;
                r.from = x.to;
                r.to = grid[x.to][i];
                r.pos = grid[grid[x.to][i]].size();
                //cout<<r.from<<" "<<r.to<<" "<<r.pos<<endl;
                qu.push(r);
                path[r.to] = max(path[r.to], path[r.from]+1);
            }
        }
        //cout<<x.from<<" "<<x.to<<endl;
    }

}
main(){
    cin>>n>>m>>a>>b;
    for(int i=0;i<m;i++){
        int u, v;
        cin>>u>>v;
        grid[u].push_back(v);
        grid[v].push_back(u);
    }
    dijkstra(a,b);
    /*cout<<"--------"<<endl;
    for(int i=1;i<=n;i++){
        cout<<i<<" "<<path[i]<<endl;
    }*/
    cout<<path[b]<<endl;
}
/*
6 7 1 6
1 2
2 4
1 3
3 4
4 5
4 6
5 6

10 12 2 5
1 10
10 9
9 8
8 7
7 6
6 5
5 4
4 6
6 10
10 3
3 2
2 1
*/
