#include<bits/stdc++.h>
const int MAXN=1e5+17;
//#define endl '\n'
using namespace std;

vector<int> G[MAXN], which[MAXN];
bool critical[MAXN], used[MAXN];
int cnt[MAXN], go[MAXN];
vector<vector<int> > cyc;

void make_cyc(int u)
{
    vector<int> temp;
    temp.push_back(u);

    int vert=u;
    while(go[vert]!=u)
    {
        temp.push_back(go[vert]);
        vert=go[vert];
    }

    for(int i=0; i<temp.size(); i++) go[temp[i]]=0;

    cyc.push_back(temp);
}

void dfs(int u, int p)
{
    used[u]=1; cnt[u]++; go[u]=p;

    for(int i=0; i<G[u].size(); i++)
        if(G[u][i]!=p&&used[G[u][i]]&&critical[G[u][i]]) {go[G[u][i]]=u; make_cyc(G[u][i]);}

    for(int i=0; i<G[u].size(); i++)
        if(G[u][i]!=p&&!used[G[u][i]]) dfs(G[u][i], u);
}

map<int, int> m[MAXN];

int dist[MAXN];
bool uu[MAXN];
void dfs_case(int u, int p)
{
    uu[u]=1;
    for(int i=0; i<G[u].size(); i++)
        if(uu[G[u][i]]==0)
        {
            dist[G[u][i]]=dist[u]+1;
            dfs_case(G[u][i], u);
        }
}

int G2[MAXN];
set<int> col[MAXN];
int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, m, a, b, cr=0;
    cin>>n>>m>>a>>b;

    for(int i=0; i<m; i++)
    {
        int u, v;
        cin>>u>>v;
        G[u].push_back(v);
        G[v].push_back(u);
    }

    for(int i=1; i<=n; i++) {if(G[i].size()>2) critical[i]=1, cr++;}
    if(cr==0)
    {
        dfs_case(a, a);
        cout<<max(dist[b], m-dist[b]);
        return 0;
    }

    for(int i=1; i<=n; i++)
        if(critical[i]&&!used[i]) dfs(i, i);

    for(int i=0; i<cyc.size(); i++)
        for(int j=0; j<cyc[i].size(); j++) col[cyc[i][j]].insert(i+1);

    int fl=0;
    for(set<int>::iterator it=col[a].begin(); it!=col[a].end(); it++)
        if(col[b].count(*it)) {fl=*it; break;}

    if(fl)
    {
        int posa, posb;
        for(int i=0; i<cyc[fl-1].size(); i++)
        if(cyc[fl-1][i]==a) posa=i;
        else if(cyc[fl-1][i]==b) posb=i;

        int sz=cyc[fl-1].size();
        cout<<max(abs(posa-posb), sz-abs(posa-posb))<<endl;
    }


    return 0;
}

/*
10 12 2 5
1 10
10 9
9 8
8 7
7 6
6 5
5 4
4 6
6 10
10 3
3 2
2 1

7 8
4 6
1 2 2 3 3 1 3 4 4 5 5 6 6 7 3 7
*/
