#include <cstdio>
#include <iostream>
#include <vector>
#include <cstring>
#include <utility>
//#include <ctime>

using namespace std;

//clock_t tstart; void startClock(){tstart=clock();}void printClock(){printf("%.4f\n", (clock()-tstart)/(CLOCKS_PER_SEC*1.0));}

int n, xx, p, curr, q, fhull, cnt;
bool turn=0;

struct Point
{
    int x, y;
};

Point all[1<<7], newp;
vector<pair<int, int> > ans;
int hull[1<<7][2], sizehull;
bool used[1<<7];

bool orientation(Point a, Point b, Point c)
{
    int ll=(a.x-b.x)*(a.y+b.y)+(b.x-c.x)*(b.y+c.y)+(c.x-a.x)*(c.y+a.y);
    return ll>0?1:0;
}

int main ()
{
    //freopen("i2.txt", "r", stdin);
    scanf("%d", &n);
    for(int i=0; i<n; ++i)
    {
        scanf("%d %d", &all[i].x, &all[i].y);
    }
    cnt=1;
    while(1)
    {
        memset(used, 0, n+1);
        sizehull=0;
        turn^=1;
        xx=1<<31-1;
        for(int i=0; i<n; ++i)
        {
            if(all[i].x<xx)
            {
                xx=all[i].x;
                p=i;
            }
        }
        do
        {
            if(used[p]) break;
            used[p]=1;
            hull[sizehull++][turn]=p;
            q=(p+1)%n;
            for(int i=0; i<n; ++i)
            {
                if(i==q) continue;
                if(orientation(all[p], all[i], all[q]))
                {
                    q=i;
                }
            }
            p=q;
        }
        while(1);
        //for(int i:hull) printf("%d ", i+1);
        //printf("\n");
        if(sizehull==n) break;
        fhull=hull[cnt%(sizehull)][turn];
        cnt++;
        for(int i=0; i<n; ++i)
        {
            if(!used[i])
            {
                ans.push_back({i+1, fhull+1});
                //printf("%d not visited - %d, %d\n", i+1, all[i].x, all[i].y);
                newp.x=all[i].x-all[fhull].x;
                newp.y=all[i].y-all[fhull].y;
                newp.x=all[fhull].x-newp.x;
                newp.y=all[fhull].y-newp.y;
                //printf("New - %d, %d\n", newp.x, newp.y);
                all[i]=newp;
            }
        }
    }
    printf("%d\n", (int)ans.size());
    for(pair<int, int> i:ans)
    {
        printf("%d %d\n", i.first, i.second);
    }
    return 0;
}
