#include<iostream>
#include<stack>
#include<vector>
#include<algorithm>

//#define endl '\n'

using namespace std;

const int MAXN=1000;
const int MAXK=200;

struct sh
{
    char br;
    int index;
};

struct combbraces
{
    int first;
    int second;
};

struct dpp
{
    int v;
    vector<int> ch;
    vector<combbraces> c;
};

/*
struct sortdp
{
    bool operator<(dpp l, dpp r)
    {
        if (l.v>r.v) return 1;
        else if (l.v<r.v) return 0;
        else for (int i=l.ch.size()-1; i>=0; i--)
        {
            if (l.ch[i]>r.ch[i]) return 1;
            else if (l.ch[i]<r.ch[i]) return 0;
        }

    }
};*/


string br;
int k, brsize;
int t[MAXN+10][MAXN+10];
dpp dp[MAXN+10];
int minp, ss, ff;
int mpc[MAXK+10];
vector<combbraces> cbr;

void input()
{
    cin>>br;
    cin>>k;
}

void output()
{
    int counter=0;
    int temp[MAXK*2];
    cout<<minp*2<<endl;
    for (int i=0; i<k; i++)
    {
        cout<<i+1<<",[";
        cout<<dp[ss].c[i].first+1<<','<<dp[ss].c[i].second+1<<"],";
        counter=0;
        for (int j=0; j<cbr.size(); j++)
        {
            if (cbr[j].first>=dp[ss].c[i].first && cbr[j].second<=dp[ss].c[i].second)
            {
                temp[counter++]=cbr[j].first;
                temp[counter++]=cbr[j].second;
            }
        }
        sort(temp, temp+counter);
        cout<<counter<<':';
        for (int i=0; i<counter; i++)
            cout<<temp[i]+1<<' ';
        cout<<endl;
    }
    for (int i=0; i<k; i++)
    {
        cout<<i+1<<",[";
        cout<<dp[ff].c[i].first+1<<','<<dp[ff].c[i].second+1<<"],";
        counter=0;
        for (int j=0; j<cbr.size(); j++)
        {
            if (cbr[j].first>=dp[ff].c[i].first && cbr[j].second<=dp[ff].c[i].second)
            {
                temp[counter++]=cbr[j].first;
                temp[counter++]=cbr[j].second;
            }
        }
        sort(temp, temp+counter);
        cout<<counter<<':';
        for (int i=0; i<counter; i++)
            cout<<temp[i]+1<<' ';
        cout<<endl;
    }
}

void fill_table()
{
    int temp;
    stack<sh> s;
    for (int i=0; i<brsize; i++)
    {
        if (!s.empty())
        {
            if (s.top().br=='(' && br[i]==')')
            {
                cbr.push_back({s.top().index, i});
                for (int j=0; j<=s.top().index; j++)
                {
                    t[j][i]++;
                }
                s.pop();
            }
            else s.push({br[i], i});
        }
        else s.push({br[i], i});
    }
    for (int i=0; i<brsize; i++)
    {
        temp=0;
        for (int j=i+1; j<brsize; j++)
        {
            t[i][j]+=temp;
            temp=t[i][j];
        }
    }
}

void cout_table()
{
    for (int i=0; i<brsize; i++)
    {
        for (int j=0; j<brsize; j++)
            cerr<<t[i][j]<<' ';
        cerr<<endl;
    }
    cerr<<endl;
}

void cout_braces()
{
    for (int i=0; i<cbr.size(); i++)
        cerr<<cbr[i].first<<' '<<cbr[i].second<<endl;
    cerr<<endl;
}

void fill_dp(int curr, int kc, int pc, vector<int> prev)
{
    if (kc==k-1)
    {
        if (dp[curr].v>pc+t[curr][brsize-1])
        {
            prev.push_back(curr);
            dp[curr].ch=prev;
            prev.pop_back();
            dp[curr].v=pc+t[curr][brsize-1];
        }
    }
    else
    {
        for (int i=curr; i<brsize-kc; i++)
        {
            prev.push_back(i);
            fill_dp(i+1, kc+1, pc+t[curr][i], prev);
            prev.pop_back();
        }
    }
}

void fill_bracesdp(int index)
{
    for (int i=0; i<k; i++)
    {
        if (i==0) dp[index].c.push_back({0, dp[index].ch[i]});
        if (i==k-1) dp[index].c.push_back({dp[index].ch[i], brsize-1});
        if (i>0 && i<k-1) dp[index].c.push_back({dp[index].ch[i-1]+1, dp[index].ch[i]});
    }
}

void cout_dp()
{
    for (int i=0; i<brsize; i++)
    {
        if (i==ss) cout<<'-';
        if (i==ff) cout<<'+';
        cerr<<dp[i].v<<": ";
        for (int j=0; j<dp[i].ch.size()-1; j++)
        {
            cerr<<dp[i].ch[j]<<' ';
        }
        cerr<<endl;
    }
    cerr<<endl;

}

void find_minp()
{
    for (int i=0; i<brsize; i++)
    {
        if (dp[i].v<minp) minp=dp[i].v;
    }
}

void find_maxdp()
{
    vector<int> v;
    int maxl;
    for (int i=0; i<brsize; i++)
    {
        if (dp[i].v==minp) v.push_back(i);
    }
    for (int j=k-1; j>=0; j--)
    {
        if (v.size()==1)
        {
            ff=v[0];
            break;
        }
        maxl=-1;
        for (int i=0; i<v.size(); i++)
        {
            if (maxl<dp[v[i]].ch[j])
            {
                maxl=dp[v[i]].ch[j];
                ff=v[i];
            }
        }
        for (int i=0; i<v.size(); i++)
        {
            if (dp[v[i]].ch[j]<maxl)
            {
                swap(v[i], v[v.size()-1]);
                v.pop_back();
            }
        }
    }

}

void find_mindp()
{
    vector<int> v;
    int minl;
    for (int i=0; i<brsize; i++)
    {
        if (dp[i].v==minp) v.push_back(i);
    }
    for (int j=k-1; j>=0; j--)
    {
        if (v.size()==1)
        {
            ss=v[0];
            break;
        }
        minl=MAXN+10;
        for (int i=0; i<v.size(); i++)
        {
            if (minl>dp[v[i]].ch[j])
            {
                minl=dp[v[i]].ch[j];
                ss=v[i];
            }
        }
        for (int i=0; i<v.size(); i++)
        {
            if (dp[v[i]].ch[j]>minl)
            {
                swap(v[i], v[v.size()-1]);
                v.pop_back();
            }
        }
    }
}

void zeroing()
{
    minp=MAXN+10;
    for (int i=0; i<brsize; i++)
    {
        dp[i].v=MAXN+10;
    }
}

void solve()
{
    vector<int> temp;
    brsize=br.size();
    fill_table();
    //cout_braces();
    //cout_table();
    zeroing();
    fill_dp(0, 0, 0, temp);
    find_minp();
    //cout<<minp<<endl;
    find_mindp();
    find_maxdp();
    fill_bracesdp(ss);
    fill_bracesdp(ff);
    //cout_dp();
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    input();
    solve();
    output();
    return 0;
}
/*
()()
3

(()(()
2

()())()
3
*/


